# /Copyright (C) 2021. Logiciel élaboré par l'État, via la Drees
# Auteurs : Bureau Retraites, Drees.
# Ce programme informatique a été développé par la Drees. 
# Bien qu'il n'existe aucune obligation légale à ce sujet, les utilisateurs de ce programme sont invités à signaler à la DREES leurs travaux issus de la réutilisation de ce code, ainsi que les éventuels problèmes ou anomalies qu'ils y rencontreraient, en ajoutant une "issue" au projet ou en écrivant à DREES-CODE@sante.gouv.fr
# Ce logiciel est régi par la licence EUPL
# À cet égard l'attention de l'utilisateur est attirée sur les risques associés au chargement, à l'utilisation, à la modification et/ou au développement et à la reproduction du logiciel par l'utilisateur étant donné sa spécificité de logiciel libre, qui peut le rendre complexe à manipuler et qui le réserve donc à des développeurs et des professionnels avertis possédant des connaissances informatiques approfondies. Les utilisateurs sont donc invités à charger et tester l'adéquation du logiciel à leurs besoins dans des conditions permettant d'assurer la sécurité de leurs systèmes et ou de leurs données et, plus généralement, à l'utiliser et l'exploiter dans les mêmes conditions de sécurité.
# Le fait que vous puissiez accéder à cet en-tête signifie que vous avez pris connaissance de la licence GPL-3.0, et que vous en avez accepté les termes.

#'listeObjetAgarder
#'@export
recupereListeObjetsAGarder <- function(){
  c("ageMax"                           ,"ageMortMax"                      ,"anneeActuelle"
    ,"anneeEic"                        ,"anneeEir"                        ,"anneeEuroConstant"
    ,"anneeMaxEacr"                    ,"anneeMaxGraphes"                 ,"anneeMinAttritionFaible"
    ,"anneeMinGraphes"                 ,"anneeProjection"                 ,"appliquerTheme"
    ,"archiverVieilleDocumentation"    ,"avecLag"                         ,"avecLagEtFigeApres60"
    ,"avecLagEtFigeApres60PriveEt52Fp" ,"branche"                         ,"calculDeltaVsRef"
    ,"calculDistrib"                   ,"calculeMeso"                     ,"capitalize"
    ,"charge"                          ,"cherche"                         ,"chercheVariablesInutiles"
    ,"controleNettoyage"               ,"creerGroupeCaisses"              ,"creerListeCoupures"
    ,"creerListeCoupuresPas5ans"       ,"creerRepertoireDoc"              ,"cutLibelle"
    ,"debutEtape"                      ,"debutNouveauSysteme"             ,"effetFixes"
    ,"estBissextile"                   ,"etape"                           ,"filtreAuto"
    ,"finEtape"                        ,"formaterEtape"                   ,"formatFrancais"
    ,"genFusionEicEir"                 ,"genMax"                          ,"genMaxEic"
    ,"genMaxGraphes"                   ,"genMin"                          ,"genMinAttritionFaible"
    ,"genMinEic"                       ,"genMinGraphes"                   ,"graine"
    ,"grapheBarres"                    ,"grapheCourbes"                   ,"grapheDistribQuanti"
    ,"graphiqueAgeDuree"               ,"graphiqueConditionRacl"          ,"graphiqueMico"
    ,"imputeAgeMort"                   ,"incrementerEtape"                ,"indFonctionLancerModeleEnCours"
    ,"infoPension"                     ,"lancerBookdown"                  ,"lancerCentralVsCor"
    ,"lancerModele"                    ,"lancerScenarioDetaille"          ,"lancerVariantesVsReference"
    ,"libelleVariable"                 ,"listeAn"                         ,"maxIntAlea"
    ,"moyPourTous2012"                 ,"moyPourTous90"                   ,"nettoyageNettoyage"
    ,"nomCentral"                      ,"nouveauSysteme"                  ,"obtenirEtapeSuivante"
    ,"obtenirListeEtapes"              ,"obtenirListeParamGlobaux"        ,"obtenirListeProgrammes"
    ,"obtenirListeTablesASauver"       ,"obtenirNomEtape"                 ,"reduireBaseIdAnVarCaisse"
    ,"repBases"                        ,"sauvegarde"                      ,"scenarioEnCours"
    ,"simpleProlongementMoy1990"       ,"simpleProlongementMoy2012"       ,"suiviEtapes"
    ,"t00"                             ,"tableau"                         ,"tauxReduction"
    ,"trouverNomRmd"                   ,"verboseCharge"                   ,"viderMemoire"
    ,"indCreerListeObjetsAGarder"      ,"listeObjetsAGarder", "scenarioCentralPourVariante"
  )
}


#'Téléchargement barèmes IPP
#'@export
telechargeBaremeIPP <- function(miseAJourIPP = TRUE){
  if(!miseAJourIPP){
    return(list(
      seriesIPP= 
        readRDS(
          system.file(
            "extdata",
            "seriesIPP.Rds",
            package = "calculPension"))))
  }
  #Pour les fichiers mixtes, 
  #je vais préciser la source, par défaut je mets historique ou IPP mais ça peut aussi être COR ou autre...
  # levelsSource <- c("IPP", "Historique")
  # caisseLevels <- c("Agirc","Arrco","CARMF complémentaire","CARMF supplémentaire","CNAVPL","Ircantec",
  #                   "Exploitant agricole","MSA exploitant complémentaire","Rafp","RSI complémentaire")
  
  #Fonction qui télécharge et une qui met en forme dta.table les fichiers de l'IPP
  #Téléchargement : récupération du .zip du projet git de l'IPP,
  #lecture des .yaml dedans, puis mise en forme une première grossière, puis par série selon les besoins
  tempdir()
  telechargementIPP <- function(){
    
    download.file(
      url = "https://framagit.org/french-tax-and-benefit-tables/baremes-ipp-yaml/-/archive/master/baremes-ipp-yaml-master.zip",
      destfile = file.path(tempdir(),"baremes-ipp-yaml-master.zip"),
      method = "libcurl")
    unzip(file.path(tempdir(),"baremes-ipp-yaml-master.zip"),
          exdir = tempdir())
  }
  
  lectureIPP <- function(){
    cheminBase <- file.path(tempdir(),
                            "baremes-ipp-yaml-master/parameters")
    cheminRetraite <- file.path(cheminBase, "retraites")
    cheminMarcheTravail <- file.path(cheminBase, "marche_travail")
    cheminSolidariteInsertion <- file.path(cheminBase, "prestations_sociales/solidarite_insertion")
    cheminPrelevementSociaux <- file.path(
      cheminBase, "prelevements_sociaux")
    
    #Ouvrir les yaml dans notepad++ pour voir leur format (ils sont légers)
    #Pour les yaml, à chaque niveau on regarde les sous niveaux hors metadata/description/documentation,
    #Si on a qu'un niveau (qui est values) on met en data.table, sinon on sapply sur chaque sous niveau
    #(avec un cas particulier si les sous niveaux sont le mois et l'année)
    yamlToDt <- function(fichierYaml){
      dtTravail <- as.data.table(fichierYaml$values)
      #On ne veut pas travailler sur les liste, on doit la passer en vecteur (avec unlist)
      #mais il faut avant remplacer les null par des NA
      dtTravailHorsNA <- sapply(dtTravail, function(x) ifelse(x=="NULL", NA, x))
      
      dtTravail <- data.table(dates = colnames(dtTravail),
                              valeur = as.numeric(unlist(dtTravailHorsNA)))
      dtTravail[, dates :=as.Date(dates)]
      dtTravail[,description:=fichierYaml$description]
    }
    
    lireFichierSousNiveaux <- function(fichierYaml, sousNiveauTxt,fichierTxt){
      #sousNiveauTxt <- "coefficient_minoration_par_trimestres_manquants"
      fichierYaml <- fichierYaml[[sousNiveauTxt]]
      variablesHorsMetadonnees <- names(fichierYaml)
      variablesHorsMetadonnees <- 
        variablesHorsMetadonnees[
          !variablesHorsMetadonnees %in% c("description", "metadata", "documentation")]
      #Si jamais les metadatas sont claqués et on pointe une série qui n'existe pas...
      if(!is.null(fichierYaml)){
        #Si un seul sous niveaux qui est values on met en data.table
        if(length(variablesHorsMetadonnees)==1 &
           variablesHorsMetadonnees[[1]]=="values"){
          fichierYaml <- yamlToDt(fichierYaml)
          fichierYaml[,sousNiveau:=sousNiveauTxt]
        }else{
          # print(fichierTxt) #Pour aide/debug
          sousSousNiveaux <- variablesHorsMetadonnees
          #Cas particulier d'une série en année mois, sinon cas général
          if(all(sousSousNiveaux %in% c("annee", "mois"))){
            fichierYamlAnnee <- yamlToDt(fichierYaml$annee)
            
            fichierYamlMois <- yamlToDt(fichierYaml$mois)
            
            fichierYamlTravail <- merge(fichierYamlAnnee,
                                        fichierYamlMois,
                                        all=T,
                                        by=c("dates"),
                                        suffixes = c(".annee", ".mois"))
            #Si on a une anné mais pas de mois : on prend 0 pour le mois,
            #si on a un mois mais pas d'année c'est que seule mois change par rapport à la dernière valeur,
            #on prend donc la dernière valeur de l'année non null
            setorder(fichierYamlTravail, dates)
            fichierYamlTravail <- 
              fichierYamlTravail[,`:=` (valeur=fcoalesce(valeur.annee, shift(valeur.annee, type="lag"))+
                                          fcoalesce(valeur.mois,0)/12,
                                        description=description.annee)][
                                          ,.(dates,valeur,description)
                                        ]
            #Controle si jamais on a deux modifications de mois sans modification d'année,
            #alors prendre juste le lag de valeur.annee (dans l'étape précédente) ne suffit pas,
            #il faut prendre la première valeure non null et pas juste la précédente
            controle <- fichierYamlTravail[,.(aucunNA = sum(is.na(valeur))<=1)]
            #ne pas écrire controle[,.(aucunNA)] sinon on a un data.table et pas une list
            stopifnot(controle[,aucunNA])
          }else{
            fichierYamlTravail <- fichierYaml[sousSousNiveaux]
            fichierYamlTravail <- rbindlist(lapply(fichierYamlTravail,
                                                   yamlToDt))
            fichierYamlTravail[,sousDescription:=description]
          }
          
          fichierYaml <- fichierYamlTravail
        }
        fichierYaml[,sousNiveau:=sousNiveauTxt]
      }
      return(fichierYaml)
    }
    
    lireFichierSeries <- function(fichierYaml,fichierTxt){
      #fichierYaml <- listeIndexApplicationFonction[[2]]
      #fichierYaml <- fichierYamlTravail
      variablesHorsMetadonnees <- names(fichierYaml)
      variablesHorsMetadonnees <- 
        variablesHorsMetadonnees[
          !variablesHorsMetadonnees %in% c("description", "metadata", "documentation")]
      stopifnot(length(variablesHorsMetadonnees)>0)
      if(length(variablesHorsMetadonnees)==1 &
         variablesHorsMetadonnees[[1]]=="values"){
        dtTravail <- yamlToDt(fichierYaml)
      }else{
        listeSousCategorie <- variablesHorsMetadonnees
        dtTravail <- rbindlist(lapply(X = listeSousCategorie,
                                      FUN = lireFichierSousNiveaux,
                                      fichierYaml = fichierYaml,
                                      fichierTxt=fichierTxt),
                               fill=T)
        
        dtTravail[,description:=fichierYaml$description]
      }
      return(dtTravail)
    }
    
    readYamlAvecFormat <- function(chemin, sousSecteur,fichierTxt){
      #On importe le fichier, principe général il faut le traiter selon son arborescence
      #(cad son nombre de niveaux de balises avant l'info)
      #Si on est directement au bon niveau on lit, sinon on applique à l'ensemble des sous niveaux
      fichierYaml <- yaml::read_yaml(paste0(chemin,"/",sousSecteur,"/",fichierTxt),
                                     fileEncoding = "UTF-8")
      #Cas particulier (si on a un niveau qui ne sert à rien et que l'on doit sauter)
      if(sousSecteur=="secteur_prive/regime_general_cnav" &
         fichierTxt=="decote.yaml"){
        fichierYaml$coefficient_minoration_par_trimestres_manquants <-
          fichierYaml$coefficient_minoration_par_trimestres_manquants$taux_minore_taux_plein_1_decote_nombre_trimestres_manquants
        
      }
      
      #Le fichier est une liste de liste, on ne garde que les liste de valuer
      #(donc hors metadata tel que description etc...)
      variablesHorsMetadonnees <- names(fichierYaml)
      variablesHorsMetadonnees <- 
        variablesHorsMetadonnees[
          !variablesHorsMetadonnees %in% c("description", "metadata", "documentation")]
      
      stopifnot(length(variablesHorsMetadonnees)>0)
      
      fichierYaml <- fichierYaml[variablesHorsMetadonnees]
      if(length(names(fichierYaml))==1 & names(fichierYaml)[[1]]=="values"){
        
        dtTravail <- lireFichierSeries(fichierYaml, fichierTxt)
      }else{
        dtTravail <- rbindlist(lapply(fichierYaml, lireFichierSeries, fichierTxt),
                               fill = TRUE)
      }
      return(dtTravail)
    }
    
    recuperationRepertoire <- function(chemin, repertoireTxt){
      # repertoireTxt <- "secteur_prive/regimes_complementaires/unirs"
      listeFichiersYamlPublic <- list.files(paste0(chemin,"/",repertoireTxt))
      #On récupère tout les fiochiers du répertoire, sauf le fichier index.
      #Il n'y a que des fichiers .yaml normalement mais on filtre quand même
      listeFichiersYamlPublic <- listeFichiersYamlPublic[!listeFichiersYamlPublic %like% "index" &
                                                           listeFichiersYamlPublic %like% "\\.yaml$"]
      
      result <- sapply(listeFichiersYamlPublic, readYamlAvecFormat,
                       sousSecteur=repertoireTxt, chemin=chemin, simplify=FALSE)
      
    }
    
    #On a des warnings qui ne gênent normalement pas. Attention certains peuvent être importants
    #Marché travail
    parametreRemuFP <- recuperationRepertoire(cheminMarcheTravail, "remuneration_dans_fonction_publique/indicefp")
    
    #Solidarite Insertion
    parametreAvts <- c(recuperationRepertoire(cheminSolidariteInsertion,
                                            "minimum_vieillesse/avts"),
                          recuperationRepertoire(cheminSolidariteInsertion,
                                            "minimum_vieillesse/avts_av_1961/villes_de_plus_de_5000_ha"))
    #Retraite
    parametrePublic <- recuperationRepertoire(cheminRetraite,repertoireTxt="secteur_public/pension_civile")
    parametreRafp <- recuperationRepertoire(cheminRetraite,repertoireTxt="secteur_public/regimes_complementaires/rafp")
    
    parametreIrcantec <- recuperationRepertoire(cheminRetraite,repertoireTxt="secteur_public/regimes_complementaires/ircantec")
    parametreIrcantecSalaireRef <- recuperationRepertoire(cheminRetraite,repertoireTxt="secteur_public/regimes_complementaires/ircantec/salaire_de_reference")
    
    
    parametreIndependants <- recuperationRepertoire(cheminRetraite,"independants")
    #Pour regime_general_cnav on a des warnings, passer outre
    parametrePriveCnav <- recuperationRepertoire(
      cheminRetraite, "secteur_prive/regime_general_cnav")
    parametrePriveAgirc <- recuperationRepertoire(
      cheminRetraite, "secteur_prive/regimes_complementaires/agirc")
    parametrePriveArrco <- recuperationRepertoire(
      cheminRetraite, "secteur_prive/regimes_complementaires/arrco")
    parametrePriveAgircArrco <- recuperationRepertoire(
      cheminRetraite, "secteur_prive/regimes_complementaires/agirc_arrco")
    parametrePriveProbtp <- recuperationRepertoire(
      cheminRetraite, "secteur_prive/regimes_complementaires/probtp")
    parametrePriveUnirs <- recuperationRepertoire(
      cheminRetraite, "secteur_prive/regimes_complementaires/unirs")
    paramPrelevementIndependants <- recuperationRepertoire(
      cheminPrelevementSociaux, "cotisations_taxes_independants_artisans_commercants")
    paramCotisationPublic <- recuperationRepertoire(
      cheminPrelevementSociaux, "cotisations_secteur_public")
    paramCotisationLiberaux <- recuperationRepertoire(
      cheminPrelevementSociaux, "cotisations_taxes_professions_liberales")
    
    
    #On supprime notre dossier temporaire en vérifiant qu'on a un code retour ok (==0)

    toto <- unlink(tempdir(), recursive = TRUE)
    stopifnot(toto==0)
    
    nomRepertoireARecuperer <- c("parametreRemuFP", "parametreAvts", "parametrePublic","parametreRafp",
                                 "parametreIrcantec","parametreIrcantecSalaireRef","parametreIndependants",
                                 "parametrePriveCnav", "parametrePriveAgirc", "parametrePriveArrco", "parametrePriveProbtp",
                                 "parametrePriveUnirs", "paramPrelevementIndependants", "paramCotisationPublic",
                                 "paramCotisationLiberaux", "parametrePriveAgircArrco")
    #lapply et get met simplement en list les list à récupérer
    result <- lapply(nomRepertoireARecuperer, FUN = function(x){get(x, envir = environment())})
    names(result) <- nomRepertoireARecuperer
    
    return(result)
  }
  
  telechargementIPP()
  lectureIPP()
}

#' Paramètres globaux
#' @export
definitParamModele<-function(){
  paramModele <- list()
  paramModele$hypSmpt<-1.0
  paramModele$scenarioMortalite<-"central"
  paramModele$hypFecondite<-"central"
  paramModele$hypImmigration<-"Centrale"
  paramModele$hypChomage<-"Sc7%"
  paramModele$mortaDiff<-TRUE
  paramModele$lura<-TRUE
  paramModele$indCorrectionRemuSexe <- FALSE
  paramModele$remuNulleHorsEqua<- TRUE # enlève-t-on les rému nulles dans l'équation de salaire ?
  paramModele$methodeEquaSal<-"salaireSansEqua"#"avecLagEtFigeApres60PriveEt52FpSansLog"#"effetFixes" # méthode pour les équations de salaire
  paramModele$anneeMinEqua<-1988
  paramModele$effetHorizon <- FALSE
  paramModele$blocageTransitionFinDeVie <- TRUE
  paramModele$tirageCategFoncParEligibilite <- FALSE
  paramModele$correctionTransitionApres60 <- TRUE
  paramModele$ageMaxTransition<-57# age max pour les transitions soumises à calage
  #sur cibles COR, au delà on laisse le modèle faire pour ne pas se baser
  #sur des hypothèses de départs à la retraite venant d'autres modèles
  paramModele$decoteQueSurAge = FALSE
  paramModele$reglePourMicoMajore <- "Normal" #"MDA en plus", "AVPF en plus", "MDA et AVPF en plus # prise en compte de la MDA/AVPFpour le MICO majoré ?
  paramModele$fonctionnaireAuTP <- TRUE
  
  # si on ne veut pas suivre des marges du COR (exp régime qui se coupe pas prévu par le COR)
  paramModele$listeMargesNonSuivies <- c() # c("cotisantCNAV","cotisantCNIEG") si on ne fait pas confiance aux cibles COR
  paramModele$fichierCorCotisant<-"hypo_cotisants_chômage_2022_V1.xlsx"
  paramModele$fichierCorSalairePrix<-"hypo_Salaires_Prix_PIB_2022_V4.xlsx"
  paramModele$fichierCorParametres<-"hypo_parametres_2022_V3.xlsx"
  paramModele$fichierCorTauxCotis <-"hypo_taux_cotisation_et_legislation_2020_drees.xlsx"
  paramModele$genMax<-2000L
  paramModele$genMaxEic<-1994L
  paramModele$genMinEic<-1942L
  paramModele$genFusionEicEir<-1950L # en 2016, la génération 1950 a 66 ans. On la considère entierement partie a la retraite (son AAD est à 65 ans)
  paramModele$genMin<-paramModele$genFusionEicEir + 1L # 1re generation simulees par le modele
  paramModele$anneeEic<-2017L #2012 2017
  paramModele$anneeEir <- 2016L
  paramModele$anneeEuroConstant <- 2020L
  paramModele$anneeActuelle <- 2023L
  paramModele$anneeProjection<-2070L
  paramModele$anneeMaxEacr <- 2020L
  paramModele$ageMax<-70L  # jusqu'à quel âge prolonge-t-on tout le monde ?
  paramModele$graine <- 1L
  paramModele$maxIntAlea <- 2E9L
  paramModele$ageMortMax <- 110L
  paramModele$verboseCharge <- TRUE # affichage des bases chargées ?
  ## Bornes d'âge pour les graphiques (bornes par tranches de 5 ans).
  # anneeMinGraphes
  # Afficher les résultats remontant environ à 10 ans dans le passé 
  # Ne pas remonter plus loin que la décénie de l'EIC actuel.
  # (remonter dans l'EIC au delà de 10 ans parait périlleux : 
  # l'info commentce à être imprécise (trop de décès)  
  # et donc inutile pour mesurer les tendnces évolutives).
  paramModele$anneeMinGraphes <- max(
    5 * as.integer(paramModele$anneeActuelle / 5) - 10, 
    10 * as.integer(min(paramModele$anneeEir, paramModele$anneeEic) / 10))
  # anneeMaxGraphes
  # 1. Ne pas projeter au delà des 40 prochaines années. 
  # 2. Projeter au max jusqu'à l'année des 55 ans de la dernière génération simulée 
  # (en dessous de cette année, presque toutes les générarions retraitées sont simulées).
  paramModele$anneeMaxGraphes <- min(
    5 * as.integer((paramModele$genMax + 55) / 5), 5 * as.integer(paramModele$anneeActuelle / 5) + 40) 
  paramModele$genMinGraphes <- 5 * as.integer(paramModele$genMin / 5)
  paramModele$genMaxGraphes <- 5 * as.integer(paramModele$genMax / 5)
  
  # Paramètres arbitrés via le programme "exploration/analyseAttrition.R".
  paramModele$anneeMinAttritionFaible <- max(paramModele$anneeEic, paramModele$anneeEir) + 1
  paramModele$genMinAttritionFaible <- 1955
  
  ### Initialisation
  # (pour conserver l'objet après viderMemoire())
  paramModele$indFonctionLancerModeleEnCours <- FALSE
  paramModele$etape <- NULL 
  paramModele$t00 <- NULL
  
  
  ### Listes 
  paramModele$listeAn <- paramModele$anneeEir: (paramModele$anneeEir + 50)
  paramModele$listeRegimesSpeciaux<-c("SNCF","ENIM","CANSSM","CAVIMAC",
                          "CNIEG","RATP","CRPCEN","BDF")
  paramModele$listeCaissesBase<-sort(c(
    "MSA salarié","Cnav","Régime spécial","RSI base",
    "CNRACL","MSA exploitant","SRE","CNAVPL",paramModele$listeRegimesSpeciaux,"nouveauSysteme"[paramModele$nouveauSysteme]))  
  paramModele$listeCaissesFonc<-sort(c(paramModele$listeRegimesSpeciaux,"Régime spécial","CNRACL","SRE"))
  paramModele$listeCaissesComp<-sort(c(
    "Ircantec","Arrco","Agirc","Agirc-Arrco","Rafp","RSI complémentaire",
    "MSA exploitant complémentaire","CARMF complémentaire",
    "CARMF supplémentaire","Complémentaire régimes spéciaux"))
  paramModele$listeCaissesRegimesAlignes<-sort(c("Cnav","MSA salarié","RSI base"))
  # attention l'ordre des états de listeEtats est important !!!!
  # la matrice de transition sera triée selon la liste Etats
  # Si dans le central, qqun avait une transition une année "Salarié du privé non cadre"->"Salarié du privé non cadre"
  # dans la variante si les probas de transition changent un peu, l'individu peut
  # basculer dans une autre transition. Le classement de liste états joue sur ce chgt de transition.
  # Pour que les comportements individuels soient comparables entre central/variante, il est préférable
  # de mettre bien dans l'ordre d'abord les états travaillés puis ensuite les non travaillés regroupés
  paramModele$listeEtats<-c(
    "Salarié du privé non cadre","Salarié du privé cadre","Contractuel de la FP","Indépendant",
    paramModele$listeRegimesSpeciaux, 
    'Régime spécial avec statut Cnav','Sans état secondaire',"AVPF", "Inactif",
    "Chômage","Maladie","Invalidité","FPE","FPT ou FPH", "Exploitant agricole",
    "MSA salarié",'Libéral',"Régime spécial",
    "Inactif ou retraité","Retraité","FPE temps partiel","FPT ou FPH temps partiel")
  paramModele$listeRegimesEquilibres <- c(
    "SRE", "Régimes spéciaux", "Régime spécial", paramModele$listeRegimesSpeciaux,
    "Complémentaire régimes spéciaux", "Rafp")
  paramModele$rendementNouveau<-5.5
  list(paramModele = paramModele)
}

#' Lecture fichiers d'hypothèse COR
#'@export
lectureHypothesesCor <- 
  function(
    fichierCorCotisant = paramModele$fichierCorCotisant,
    fichierCorSalairePrix = paramModele$fichierCorSalairePrix,
    fichierCorParametres = paramModele$fichierCorParametres,
    fichierCorTauxCotis = paramModele$fichierCorTauxCotis, 
    paramModele){
  # 4 fichier COR -> vérifier qu'ils soient à jour, sauf hypo_taux_cotis_et_legislation qui peut dater un peu
  
  # Hypothèse 2021 pour primes fonctionnaire pour l'instant
  ensembleHypSmpt <- c("0.7", "1.0", "1.3", "1.6")
  ##### hypo_cotisants_chômage -------------
  
  cotisantsChomeursCor<-
    rbindlist(
      lapply(c("Sc7%","Var4,5%","Var10%"),function(x){
        dt<-cbind(readxl::read_excel(
          system.file("extdata",fichierCorCotisant, package = "calculPension"),
          sheet=x,range="Z4:AP59"),
          readxl::read_excel(
            system.file("extdata",fichierCorCotisant, package = "calculPension"),
            sheet=x,range="B4:C59"))
        setDT(dt)
        dt[,`:=`(
          # pas de cibles de régimes spéciaux a priori pour l'instant
          cotisantCnav = CNAV,
          cotisantCNRACL = CNRACL,
          cotisantMSAExp = MSA_EXA,
          cotisantMSASal = MSA_SA,
          cotisantSRE=`FPE civils et militaires`+FSPOEIE,
          cotisantCANSSM = CANSSM,
          cotisantSNCF = SNCF,
          cotisantRATP = RATP,
          cotisantENIM = ENIM,
          cotisantCNIEG = CNIEG,
          cotisantCRPCEN = CRPCEN,
          cotisantRSI = `Régime général des non salariés`,
          cotisantBDF = BDF,
          cotisantCNAVPL=CNAVPL_RB+CNBF_RB,
          emploiTotal = `Emploi total`,
          chomeur=`Emploi total`*`Taux de chômage BIT`/100/(1-`Taux de chômage BIT`/100)
        )]
        setnames(dt,'Année',"annee")
        melt(dt,id.vars="annee")[,scenario:=x]
      }))
  
  ##### hypo_Salaires_Prix_PIB -------------
  
  ## indice des prix
  prixCor<-readxl::read_excel(
    system.file("extdata",fichierCorSalairePrix, package = "calculPension"),
    sheet="Prix", range = "B5:F127", .name_repair = "minimal")
  setDT(prixCor)
  names(prixCor)[1]<-"annee"
  prixCor <- melt(
    data = prixCor,
    id.vars = "annee")[, .(
      annee, 
      hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
      indicePrix = value)] 
  # creation dtInflation
  prixCor <- 
    prixCor[order(hypSmpt, annee)][,
                                   .(annee, inflation = 100 * (indicePrix / shift(indicePrix) - 1)),"hypSmpt"][
                                     !is.na(inflation)] 
  
  
  # prolongement dtInflation
  lignesAAjouter <-prixCor[annee==max(annee),!"annee"][
    CJ(
      hypSmpt = as.numeric(ensembleHypSmpt),
      annee = (prixCor[,max(annee)]+1):(paramModele$genMax + paramModele$ageMortMax)),on="hypSmpt"]
  prixCor <- rbind(
    prixCor,lignesAAjouter)
  
  # Calcul cumInflation
  prixCor <- prixCor[
    order(hypSmpt,annee)][,
                          cumInflation := cumprod(1 + inflation / 100),"hypSmpt"]
  
  
  prixCor <- prixCor[,.(
    annee, inflation, cumInflation, hypSmpt,
    coefInflationEuroConstant = 
      prixCor[annee == paramModele$anneeEuroConstant]$cumInflation / cumInflation )]
  
  # smptNominal
  smptNominal<-readxl::read_excel(
    system.file("extdata",fichierCorSalairePrix, package = "calculPension"),
    sheet="SMPT", range = "B5:F127", .name_repair = "minimal")
  setDT(smptNominal)
  names(smptNominal)[1]<-"annee"
  smptHistorique<-smptNominal[1:(min(which(smptNominal[,2]!=smptNominal[,3]))-1),1:2]
  names(smptHistorique)[2]<-"smpt"
  
  # smic
  smicCor<-readxl::read_excel(
    system.file("extdata",fichierCorSalairePrix, package = "calculPension"),
    sheet="SMIC", range = "B5:F125", .name_repair = "minimal")
  setDT(smicCor)
  names(smicCor)[1]<-"annee"
  smicCor <- melt(
    data = smicCor,
    id.vars = "annee")[, .(
      annee, 
      hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
      smicCor = value)] 
  
  # PSS
  pssCor<-readxl::read_excel(
    system.file("extdata",fichierCorSalairePrix, package = "calculPension"),
    sheet="PSS", range = "B5:F127", .name_repair = "minimal")
  setDT(pssCor)
  names(pssCor)[1]<-"annee"
  pssCor <- melt(
    data = pssCor,
    id.vars = "annee")[, .(
      annee, 
      hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
      pssCor = value)] 
  
  # PIB
  pibCor<-readxl::read_excel(
    system.file("extdata", fichierCorSalairePrix, package = "calculPension"),
    sheet="PIB", range = "B5:F127", .name_repair = "minimal")
  setDT(pibCor)
  names(pibCor)[1]<-"annee"
  pibCor <- melt(
    data = pibCor,
    id.vars = "annee")[, .(
      annee, 
      hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
      pib = value * 1E9)] 
  
  # SMPT traitements et prumes
  
  #Uniquement les traitements (hors FP, les traitements sont les rémus)
  lectureSmpttraitements <- function(hypSmpt_){
    smptTraitements <- readxl::read_excel(
      system.file("extdata",fichierCorSalairePrix,package = "calculPension"),
      sheet=paste0("SMPT_rég_",substr(hypSmpt_,1,1),",",substr(hypSmpt_,3,3)," %"),
      skip = 4,.name_repair = "minimal")
    setDT(smptTraitements)
    smptTraitements<-smptTraitements[,c(1,19:35)]
    names(smptTraitements)<-c("annee","Ensemble économie", "Cnav", "MSA salarié",
                              "SRE", "FSPOEIE", "CNRACL",
                              "CANSSM", "SNCF", "RATP",
                              "ENIM", "CNIEG", "CRPCEN",
                              "BDF", "MSA exploitant", "RSI base",                     
                              "CNAVPL", "CNBF")
    smptTraitements <- melt(smptTraitements,
                            id.vars = c("annee"))
    
    smptTraitements <- smptTraitements[,.(annee, caisse = variable, evolution = 100*value)][
      !is.na(evolution)
    ]
    
    smptTraitements[, hypSmpt := as.numeric(hypSmpt_)]}
  smptTraitementsCor <- rbindlist(lapply(ensembleHypSmpt, lectureSmpttraitements))
  
  
  
  #Les traitements et les primes FPE
  fpeTraitementPrimes <- readxl::read_excel(
    system.file("extdata", fichierCorSalairePrix,package = "calculPension"),
    sheet=paste0("SMPT_FPE"),
    skip=4,.name_repair = "minimal")
  
  
  #Les traitements et les primes CNRACL
  cnraclTraitementPrimes <- readxl::read_excel(
    system.file("extdata", fichierCorSalairePrix, package = "calculPension"),
    sheet=paste0("TI_SMPT_CNRACL"),
    skip=4,.name_repair = "minimal")
  
  
  traitementPrimes <- function(tableSmpt){
    
    setDT(tableSmpt)
    # colToSelect <- fcase(hypSmpt==1.8,list(c("Sc_1,8%...2", "Sc_1,8%...6")),
    #                      hypSmpt==1.5,list(c("Sc_1,5%...3", "Sc_1,5%...7")),
    #                      hypSmpt==1.3,list(c("Sc_1,3 %...4", "Sc_1,3 %...8")),
    #                      hypSmpt==1.0,list(c("Sc_1,0%...5", "Sc_1,0%...9"))
    # )
    # colToSelect <- c("...1", unlist(colToSelect))
    # tableSmpt <- tableSmpt[,..colToSelect]
    tableSmpt <- tableSmpt[,1:5] #On garde 9 premières colonnes
    names(tableSmpt)<-gsub(",",".",substr(names(tableSmpt),4,6))
    names(tableSmpt)[1]<-"annee"
    
    tableSmpt <- data.table::melt(tableSmpt,
                                  id.vars = c("annee"), variable.name="hypSmpt", value.name = "evolution")
    tableSmpt[, hypSmpt := as.numeric(as.character(hypSmpt))]
    
    tableSmpt[!is.na(evolution)]
  }
  
  fpeTraitementPrimes <-traitementPrimes(fpeTraitementPrimes)
  cnraclTraitementPrimes <- traitementPrimes(cnraclTraitementPrimes)
  traitementEtPrimes<-rbind(
    fpeTraitementPrimes[,caisse:="SRE"],
    cnraclTraitementPrimes[,caisse:="CNRACL"]
  )
  
  ##### hypo_parametres -------------
  
  revaloSamCor<-readxl::read_excel(
    system.file("extdata", fichierCorParametres, package = "calculPension"),
    sheet="Revalo_RB", range = "B6:D131", .name_repair = "minimal")
  setDT(revaloSamCor)
  revaloSamCor<-revaloSamCor[,-2]
  names(revaloSamCor)<-c("annee","revaloSam")
  revaloSamCor <- revaloSamCor[!is.na(annee)]
  revaloSamCor[,revaloSam:=100*revaloSam]
  revaloSamCor[is.na(revaloSam), revaloSam:=0]
  
  # revaloSamCor<-readxl::read_excel(
  #   system.file("extdata","hypo_parametres_2021.xlsx", package = "calculPension"),
  #   sheet="Revalo_RB", range = "B6:D130", .name_repair = "minimal")
  # setDT(revaloSamCor)
  # revaloSam<-revaloSamCor[,-2]
  # names(revaloSamCor)<-c("annee","revaloSam")
  # revaloSamCor[,revaloSam:=revaloSam*100]
  
  revaloRBCor<-readxl::read_excel(
    system.file("extdata",fichierCorParametres, package = "calculPension"),
    sheet="Revalo_RB", range = "F6:I131", .name_repair = "minimal")
  setDT(revaloRBCor)
  names(revaloRBCor)[2]<-"date"
  revaloRBCor<-revaloRBCor[!is.na(date),-1]
  revaloRBCor[,date:=as.anneeMois(as.Date(date))]
  
  ## on fait sauter la colonne penion > 2000 car c'est dans le passé et le passé n'est 
  # pas géré par le Cor
  # mais par les barèmes IPP
  revaloRBCor<-revaloRBCor[,-3]
  names(revaloRBCor)<-c("date","revaloRBCor")
  revaloRBCor[, revaloRBCor:=revaloRBCor * 100]
  
  # salaire validant
  salaireValidantCor<-readxl::read_excel(
    system.file("extdata",fichierCorParametres, package = "calculPension"),
    sheet="Sal_valid", range = "B5:F127", .name_repair = "minimal")
  setDT(salaireValidantCor)
  names(salaireValidantCor)[1]<-"annee"
  salaireValidantCor <- melt(
    data = salaireValidantCor,
    id.vars = "annee")[, .(
      annee, 
      hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
      salaireValidantCor = value)] 
  
  
  # smic AVPF
  smicAVPFCor<-readxl::read_excel(
    system.file("extdata",fichierCorParametres, package = "calculPension"),
    sheet="Smic_AVPF", range = "B5:F104", .name_repair = "minimal")
  setDT(smicAVPFCor)
  names(smicAVPFCor)[1]<-"annee"
  smicAVPFCor <- melt(
    data = smicAVPFCor,
    id.vars = "annee")[, .(
      annee, 
      hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
      smicAVPFCor = value)] 
  
  # valeur point Agirc arrco
  ptsAgircArrcoCor<-readxl::read_excel(
    system.file("extdata",fichierCorParametres, package = "calculPension"),
    sheet="AGIRC-ARRCO", range = "B5:J57", .name_repair = "minimal")
  setDT(ptsAgircArrcoCor)
  names(ptsAgircArrcoCor)[1]<-"annee"
  ptAcquisitionAgircArrcoCor <-
    melt(
      data = ptsAgircArrcoCor[,1:5],
      id.vars = "annee")[, .(
        annee, 
        hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
        valeurPtAcquisition = value)]
  ptServiceAgircArrcoCor <-  melt(
    data = ptsAgircArrcoCor[,c(1,6:9)],
    id.vars = "annee")[, .(
      dateLiq=anneeMois(annee,11), 
      hypSmpt = as.numeric(gsub(x=substr(variable, 4,6),pattern = ",", replacement = ".")),
      valeurPtService  = value)]
  
  # minima
  minima<-readxl::read_excel(
    system.file("extdata",fichierCorParametres, package = "calculPension"),
    sheet="Minima", .name_repair = "minimal")
  setDT(minima)## chiant car on n'aura pas la profondeur historique
  # dans ce fichier, il faudra sûrement faire un raccordement avec un 
  # autre fichier -> chiant
  cor1<-minima[-(1:5),c(2:6)]
  cor1<-cor1[,lapply(cor1,FUN=as.numeric)]
  names(cor1)<-c("date","1.8","1.5","1.3","1.0")
  cor1[, dateLiq:=as.anneeMois(as.Date(date, origin="1900-1-1"))][,date:=NULL]
  plafondMicoCor<-melt(cor1, id.vars="dateLiq", variable.name = "hypSmpt", 
                       value.name = "plafondMicoCor")[
                         !is.na(plafondMicoCor)][,hypSmpt:=as.numeric(hypSmpt)]
  
  cor2<-minima[-(1:5),c(13:18)]
  names(cor2)<-c("dateLiq","Minimum contributif",
                 "Minimum contributif majoré","Minimum garanti dans la FP",
                 "PMR 1",	"PMR 2")
  cor2<-cor2[!is.na(dateLiq)]
  cor2<-cor2[,lapply(cor2,FUN=as.numeric)]
  cor2[, dateLiq:=as.anneeMois(as.Date(dateLiq, origin="1900-1-1"))]
  minimaDivers<-cor2
  
  cor3<-minima[-(1:5),c(13,19:22)]
  names(cor3)<-c("date","1.6","1.3","1.0","0.7")
  cor3<-cor3[!is.na(date)]
  cor3<-cor3[,lapply(cor3,FUN=as.numeric)]
  cor3[, dateLiq:=as.anneeMois(as.Date(date, origin="1900-1-1"))][,date:=NULL]
  complementDiffRCOCor<-melt(cor3, id.vars="dateLiq", variable.name = "hypSmpt", 
                          value.name = "complementDiffRCOCor", variable.factor = FALSE)[
                            !is.na(complementDiffRCOCor)][, hypSmpt:=as.numeric(hypSmpt)]
  
  # aspa (pour écrêtement PMR MSA exploitant)
  aspa<-readxl::read_excel(
    system.file("extdata",fichierCorParametres, package = "calculPension"),
    sheet="ASPA", .name_repair = "minimal", range = "C6:E73")
  setDT(aspa)
  aspa<-aspa[,c(1,3)]
  names(aspa)<-c("date","aspaCor")
  aspaCor<-aspa[,dateLiq:=as.anneeMois(as.Date(date, origin="1900-1-1"))][,date:=NULL]
  
  micoCor<-melt(
    minimaDivers[
      ,.(
        dateLiq,
        micoPlein=`Minimum contributif`,
        micoMajorePlein=`Minimum contributif majoré`-`Minimum contributif`)],
    id.vars="dateLiq", value.name = "valeur")
  micoCor <- micoCor[!is.na(valeur)]
  
  ##### hypo_taux_cotisation_et_legislation -------------
  
  paramCotis <- setDT(readxl::read_excel(
    system.file("extdata",fichierCorTauxCotis,
                package = "calculPension"),
    sheet=paste0("TxCot"), .name_repair = "minimal"))
  
  ### séparation valeur historique et prolongement 
  ### (un peu artificiel mais nécessaire pour variantes)
  ## concerne les séries dont l'historique est pris au COR et non à l'IPP
  ## à enlever si un jour on se branche sur l'IPP pour ces séries
  
  ## hypSmpt n'a pas d'importance 
  pss <- pssCor[annee<=paramModele$anneeActuelle - 1 & hypSmpt==1.3, .(annee, pss=pssCor)]
  smic <- smicCor[annee<=paramModele$anneeActuelle - 1 & hypSmpt==1.3, .(annee, smic=smicCor)]
  salaireValidant<-salaireValidantCor[annee<=paramModele$anneeActuelle - 1 & hypSmpt==1.3,.(annee, salaireValidant=salaireValidantCor)]
  smicAVPF <- smicAVPFCor[annee<=paramModele$anneeActuelle - 1 & hypSmpt==1.3,.(annee, smicAVPF=smicAVPFCor)]
  plafondMico <- plafondMicoCor[extraireAnnee(dateLiq)<=paramModele$anneeActuelle & hypSmpt==1.3,.(dateLiq, plafondMico=plafondMicoCor)]
  revaloSam <-revaloSamCor[annee<=paramModele$anneeActuelle]
  mico <- micoCor[extraireAnnee(dateLiq) <=paramModele$anneeActuelle]
  complementDiffRCO <- complementDiffRCOCor[extraireAnnee(dateLiq)<=paramModele$anneeActuelle 
                                            & hypSmpt==1.3,.(dateLiq,complementDiffRCO=complementDiffRCOCor)] 
  aspa <- aspaCor[extraireAnnee(dateLiq)<=paramModele$anneeActuelle 
                  ,.(dateLiq,aspa=aspaCor)]
  
  
  
  list(
    seriesConnuesCor = list(
      smptHistorique = smptHistorique, pss = pss, smic = smic,
      salaireValidant = salaireValidant, smicAVPF = smicAVPF,
      plafondMico = plafondMico, revaloSam = revaloSam, mico=mico,
      complementDiffRCO=complementDiffRCO, aspa=aspa),
    seriesProlongees = list(
    ptServiceAgircArrcoCor = ptServiceAgircArrcoCor,
    ptAcquisitionAgircArrcoCor = ptAcquisitionAgircArrcoCor, smicCor = smicCor,
    salaireValidantCor = salaireValidantCor,smicAVPFCor = smicAVPFCor, 
    plafondMicoCor = plafondMicoCor, pibCor = pibCor,
    cotisantsChomeursCor = cotisantsChomeursCor,
    smptTraitementsCor = smptTraitementsCor, traitementEtPrimes = traitementEtPrimes,
    paramCotis = paramCotis, minimaDivers = minimaDivers,
    revaloRBCor = revaloRBCor, micoCor = micoCor, revaloSam = revaloSam,
    revaloSamCor = revaloSamCor,pssCor = pssCor, prixCor = prixCor, 
    complementDiffRCOCor=complementDiffRCOCor, aspaCor = aspaCor))
}



#' Paramètres autres
#' @export
lectureAutresParametres <- function(
    paramCotis = seriesProlongees$paramCotis,
    minimaDivers = seriesProlongees$minimaDivers,
    paramModele
){
  # Date à laquelle les régimes spéciaux cessent d'embaucher sous le statut
  dateFermetureRegSpe<-data.table(caisse=c("SNCF"), dateFin=anneeMois(2020,1))
  
  paramCotisCor <- copy(paramCotis)
  
  parametres = 
    readRDS(
      system.file("extdata","parametres.Rds", package = "calculPension"))
  invisible(lapply(
    names(parametres),
    function(x)assign(envir=parent.frame(2),x=x,value=parametres[[x]])))
  
  mico<-
    rbind(
      paramMico[
        caisse=="Cnav"& 
          dateLiq<minimaDivers[,as.anneeMois(min(dateLiq))],
        .(dateLiq, type, value)],
      melt(
        minimaDivers[
          ,.(dateLiq, micoPlein=`Minimum contributif`,
             micoMajorePlein=`Minimum contributif majoré`-`Minimum contributif`)],
        id.vars="dateLiq", variable.name='type')
    )
  pmr<-
    rbind(
      pmr[
        dateLiq<minimaDivers[,as.anneeMois(min(dateLiq))],
        .(dateLiq, PMR1,PMR2)],
      minimaDivers[
        ,.(dateLiq, PMR1=`PMR 1`, PMR2=`PMR 2`)]
    )
  pmr<-pmr[!is.na(PMR1)]
  
  # les taux de cotis qu'on ne trouve pas dans le fichier du COR
  paramCotis<-
    paramCotis[
      ,.(annee, txCotSNCF_sal, txCotSNCF_empl_T1, txCotSNCF_empl_T2,
         txCotCNAVPL_T1, txCotCNAVPL_T2,txCotRSI_sousplaf, txCotRSI_tot,txCotMSA_AVI,
         txCotMSA_AVA_sousplaf, txCotMSA_AVA_tot,txCotRAFP_sal, txCotRAFP_empl,
         txCotIRCANTECsal_TA, txAppel_Ircantec, plafondTBIrcantec, 
         txCotIRCANTECsal_TB, txCotIRCANTECempl_TA, txCotIRCANTECempl_TB,txCotCARMF,
         txCotASV,txCotRSI_Comp_TA, txCotRSI_Comp_TB,txCotMSANSA_comp,plafondTBArrco,
         salaireCharniereAgirc, txCotAGFFsal_tC,
         txCotAGFFempl_tC)][
           paramCotisCor, on =.(annee)]
  
  paramImmigration<-
    readRDS(system.file("extdata","paramImmigration.Rds", package = "calculPension"))
  #diffSalaireSexe<-readRDS(file.path("calcul_pension","inst","extdata","diffSalaireSexe.Rds"))
  # ancien fichier chelou avec bcp moins d'enfants chez les hommes que chez les femmes
  # paramNbEnfant<-
  #   readRDS(file=file.path("parametres",'paramNbEnfant.Rds'))
  freqNbEnfantGenerique<-
    readRDS(system.file("extdata","freqNbEnfantGenerique.Rds", package = "calculPension"))
  distribNaissance <- readRDS(system.file("extdata","distribNaissance.Rds", package = "calculPension"))
 
  #probaLiquidation<-readRDS(
  # file=file.path("parametres","probaLiquidation.Rds"))
  # txCotisNouveau<-readRDS(file = file.path("parametres","txCotisNouveau.Rds"))
  # paramMultiplicateurPss<-readRDS(file = file.path("parametres","paramMultiplicateurPss.Rds"))
  # micoNouveau<-readRDS(file = file.path("parametres","micoNouveau.Rds"))
  # agePivot<-readRDS(file = file.path("parametres","agePivot.Rds"))
  
  # on complète le fichier de paramètres avec les régimes spéciaux (tous sur le même modèle), si on fait le détail
  # des règles de ces régimes un jour, ces lignes sauteront
  regSpe<-coeffDecote[caisse == "Régime spécial", !"caisse"]
  coeffDecote<-
    rbind(
      regSpe[
        CJ(caisse=paramModele$listeRegimesSpeciaux,generation=regSpe$generation),
        on = .(generation)],
      coeffDecote)
  regSpe<-coeffSurcote[caisse == "Régime spécial", !"caisse"]
  coeffSurcote<-
    rbind(
      regSpe[
        CJ(caisse=paramModele$listeRegimesSpeciaux,anneeLiq=regSpe$anneeLiq),
        on = .(anneeLiq)],
      coeffSurcote)
  regSpe<-revalo[caisse == "Régime spécial", !"caisse"]
  revalo<-
    rbind(
      regSpe[
        CJ(caisse=paramModele$listeRegimesSpeciaux,dateValeurPension=as.anneeMois(unique(regSpe$dateValeurPension))),
        on = .(dateValeurPension)],
      revalo)
  regSpe<-majoEnfantSimple[caisse == "Régime spécial", !"caisse"]
  majoEnfantSimple<-
    rbind(
      regSpe[
        CJ(caisse=paramModele$listeRegimesSpeciaux,nbEnfant=unique(regSpe$nbEnfant),sexe=unique(regSpe$sexe)),
        on = .(nbEnfant, sexe)],
      majoEnfantSimple)

  parametres = list(
    conditionRacl=conditionRacl,
    dateFermetureRegSpe=dateFermetureRegSpe,
    revalo=revalo, paramImmigration = paramImmigration, diffSalaireSexe =diffSalaireSexe,
    paramCotis = paramCotis, 
    valeurPtAcquisition = valeurPtAcquisition, 
    plancherCARMF = plancherCARMF,
    plafondCARMF = plafondCARMF,
    forfaitASV = forfaitASV, freqNbEnfantGenerique = freqNbEnfantGenerique,
    distribNaissance = distribNaissance, ageDuree = ageDuree, #probaLiquidation,
    #probaResid,
    coeffDecote = coeffDecote,
    coeffDecoteFP = coeffDecoteFP,
    complDecoteAge = complDecoteAge, complDecoteDuree = complDecoteDuree,
    coeffSurcote = coeffSurcote, surcoteRafp = surcoteRafp,
    surcoteIrcantec = surcoteIrcantec,
    valeurPtService = valeurPtService, minorationMiga = minorationMiga,
    paramMiga = paramMiga, revaloMico = revaloMico, pmr = pmr,
    majoEnfantSimple = majoEnfantSimple, majoEnfantAA = majoEnfantAA,
    vfuSeuilEuro = vfuSeuilEuro,vfuSeuilPt = vfuSeuilPt, vfuCoefRA = vfuCoefRA,
    rnipp = rnipp, mico=mico,vfuCoefAA=vfuCoefAA,
    vfuCoefIrcantec=vfuCoefIrcantec
   # "txCotisNouveau","paramMultiplicateurPss","micoNouveau","agePivot"
    #Liste des tables remplacées par celles de l'IPP, à supprimer à long terme
    #"garantieMinimalePtsAgirc","nbAnPourSam", 
    # "revaloSalaireSam", "avts", "mico",
  )
  list(parametres = parametres)
}

#' @export
miseEnFormeIPP <- function(seriesIPP, paramModele){
# Attention, ce n'est pas encore les paramètres trajectoire pour certaines séries
# Par exemple les revalorisations de régimes à pouint doivent être définies,
# et d'autres séries raccordées à celles historique (manque certaines caisses)

#Garantie minimale point agirc //////////////////////////////////////////////////
#remplace garantieMinimalePtsAgirc.Rds
garantieMinimalePtsAgirc <- copy(seriesIPP$parametrePriveAgirc$gmp.yaml)
garantieMinimalePtsAgirc[is.na(valeur), valeur:=0]
garantieMinimalePtsAgirc <- garantieMinimalePtsAgirc[
  ,.(annee=year(dates), garantieMinimale = valeur)]
stopifnot(nrow(garantieMinimalePtsAgirc[is.na(garantieMinimale)])==0)

#  RG trimestres taux plein //////////////////////////////////////////////////
#Durée requise du régime général droit commun
suppressWarnings(
  ageTauxPleinRG <- copy(seriesIPP$parametrePriveCnav$trimtp.yaml)[
    !is.na(valeur)][
      ,dateNaissance:=fifelse(
        substr(sousNiveau, 1, 6)=="before",
        as.anneeMois("1900-01"),
        as.anneeMois(paste0(substr(sousNiveau, 7, 10),
                            "-",
                            substr(sousNiveau, 12, 13))))][
                              ,dateEffet:=as.anneeMois(dates)][
                                ,.(dateNaissance, dateEffet, valeur)]
)
stopifnot(nrow(ageTauxPleinRG[is.na(valeur)])==0)

#Années prises en compte dans le SAM (indépendant et RG) /////////////////////////////

nbAnPourSAMindependants <- copy(seriesIPP$parametreIndependants$ram.yaml)[!is.na(valeur)]

suppressWarnings(nbAnPourSAM <- copy(seriesIPP$parametrePriveCnav$sam.yaml)[
  !is.na(valeur)][
    ,dateEffet := as.anneeMois(dates)][
      ,generation := fifelse(substr(sousNiveau, 1, 6)=="before",
                             1900L,
                             as.integer(substr(sousNiveau, 7, 10)))][
                               ,.(generation, dateEffet, nbAnneesRetenues = valeur)
                             ]
)

#Un warning qui ne pose pas problème
suppressWarnings(
  nbAnPourSAMindependants <- nbAnPourSAMindependants[
    , .(dateEffet = as.anneeMois(dates),
        generation = fcase(substr(sousNiveau, 1, 6)=="before",
                           1900L,
                           substr(sousNiveau, 1, 5)=="after",
                           as.integer(substr(sousNiveau, 7, 10)),
                           default=as.integer(NA)),
        caisse = "RSI base",
        valeur=valeur)]
)

#Nouveau fichier de paramètres :
#@ATTENTION noms de caisses à la main
#à voir si ce n'est pas dans la jointure où on utilise le ficheir qu'il faut mettre ça
nbAnPourSAM <- rbind(copy(nbAnPourSAM)[,caisse:="Cnav"],
                     copy(nbAnPourSAM)[,caisse:="MSA salarié"])

setnames(nbAnPourSAMindependants, "valeur", "nbAnneesRetenues")

nbAnPourSam <- rbind(nbAnPourSAMindependants,
                     nbAnPourSAM)
#On a une date d'effet qu'on ne garde pas (2004 pour RSI : pas très utile, s'applique presque à tous le monde dans le modèle)
nbAnPourSam <- nbAnPourSam[
  , .(caisse, nbAnPourSam = as.integer(nbAnneesRetenues), generation)]

stopifnot(nrow(nbAnPourSam[is.na(nbAnPourSam)])==0)

# Point Indice FP //////////////////////////////////////////////////
pointIndiceFP <- copy(seriesIPP$parametreRemuFP$point_indice_en_euros.yaml)[
    ,.(dateLiq=as.anneeMois(dates), valeur)]

stopifnot(nrow(pointIndiceFP[,.N,.(dateLiq)][N>1])==0)
stopifnot(nrow(pointIndiceFP[is.na(valeur)])==0)

#Mico //////////////////////////////////////////////////
#remplace paramMico (qui est ensuite prolongé par le cor)
mico <- copy(seriesIPP$parametrePriveCnav$montant_mico.yaml)[sousNiveau=="annuel"]
mico[, description:=fcase(description=="Minimum contributif",
                          "micoPleinIPP",
                          description=="Minimum contributif majoré",
                          "micoMajorePleinIPP",
                          default = "problème : cas non géré")]
mico <- dcast(mico,formula="dates~description",
              value.var = "valeur")
mico[,dateLiq :=as.anneeMois(dates)][,dates:=NULL]
#Ok après 2001, avant on est en franc sur le mico IPP, je multiplie par 0.152449
mico[dateLiq<=as.anneeMois("2001-01"),
     `:=` (micoPleinIPP = 0.152449*micoPleinIPP,
           micoMajorePleinIPP = 0.152449*micoMajorePleinIPP)]

mico[, micoMajorePleinIPP:=micoMajorePleinIPP-micoPleinIPP]
mico <- mico[
  , .(micoPlein = micoPleinIPP, micoMajorePlein=micoMajorePleinIPP, dateLiq)]
#On somme les deux mico, donc 0 sur le passé si le majoré n'existait pas
mico[is.na(micoMajorePlein), micoMajorePlein:=0]

mico <- melt(mico,
             id.vars = "dateLiq",
             variable.name = "variable",
             value.name = "valeur")
stopifnot(nrow(mico[,.N,.(dateLiq, variable)][N>1])==0)
stopifnot(nrow(mico[is.na(valeur)])==0)
#Plafond Mico //////////////////////////////////////////////////
#Dans trajectoire c'est des chiffres du COR contrairement au valeur de mico
#Donc, on n'utilise pas : à supprimer ?
plafondMicoIpp <- copy(seriesIPP$parametrePriveCnav$plafond_mico.yaml)[
  ,.(dateLiq=as.anneeMois(dates), valeur)]

stopifnot(nrow(plafondMicoIpp[,.N,.(dateLiq)][N>1])==0)
#RevaloSAM //////////////////////////////////////////////////

revaloSalaireSam <- copy(seriesIPP$parametrePriveCnav$reval_s.yaml)[description=="Coefficient"][
  ,dateLiq := as.anneeMois(dates)][
    ,.(revalo = valeur,dateLiq)]

stopifnot(nrow(revaloSalaireSam[,.N,.(dateLiq)][N>1])==0)
#AVTS ////////////////////////////////////////////////////////
avts <- rbind(
  copy(seriesIPP$parametreAvts$montants_annuels.yaml)[, .(dateLiq=as.anneeMois(dates), avts=valeur)][
      dateLiq<=as.anneeMois("2001-01"), avts:=0.152449*avts #Passage Franc euro
    ],
  copy(seriesIPP$parametreAvts$allocation_de_base.yaml)[ #Choix : Villes de plus de 5000 habitants
                                                      ,.(dateLiq=as.anneeMois(dates), avts=valeur)][
                                                        ,avts:=0.152449*avts][ #Au mieux on est en Franc
                                                          dateLiq<as.anneeMois("1960-01"), avts:=0.01*avts #Passage Ancien Franc Franc
                                                        ])

stopifnot(nrow(avts[,.N,.(dateLiq)][N>1])==0)
#Taux cotisation RSI /////////////////////////////////////////////////////////////
# txCotRSI_sousplaf, txCotRSI_tot
txCotisationRSI <- copy(seriesIPP$paramPrelevementIndependants$ret_ac.yaml)[
  sousNiveau=="tout_salaire"|(sousNiveau=="sous_pss" & description=="Artisans")]
txCotisationRSI[is.na(valeur), valeur:=0]
#Attention, les taux sont jusqu'à présent annuels, mais en 1976 on en a deux ici, on garde en date et on adapte le code ?
txCotisationRSI[,dates:=as.anneeMois(dates)][
  , serie:=fifelse(sousNiveau=="sous_pss",
                   "txCotRSI_sousplaf",
                   "txCotRSI_tot")
]
txCotisationRSI <- txCotisationRSI[,.(dates, valeur, serie)]
txCotisationRSI <- dcast(txCotisationRSI, formula = dates~serie, value.var = "valeur")
setorder(txCotisationRSI, dates)
lapply(X =list("txCotRSI_sousplaf", "txCotRSI_tot"),
       FUN = function(x)txCotisationRSI[, x:= nafill(x, type="locf"), env=list(x=x)])
stopifnot(nrow(txCotisationRSI[is.na(txCotRSI_sousplaf) | is.na(txCotRSI_tot)])==0)
stopifnot(nrow(txCotisationRSI[,.N,.(dates)][N>1])==0)
#Taux cotisation RSI ///////////////////////////
#Mise en format wide pour le coller, ensuite on NA.fill ce qu'il faut
# txCotisationRSI <- dcast(txCotisationRSI[,.(annee, valeur, serie)],
#                          formula = annee ~ serie,
#                          value.var = "valeur",
#                          fun.aggregate = mean)
# 
# txCotisationRSI[, txCotRSI_sousplaf:=nafill(txCotRSI_sousplaf, type = "locf")]
# txCotisationRSI[, txCotRSI_tot:=nafill(txCotRSI_tot, type = "locf")]

#Taux cotisation SNCF /////////////////////////////////////////////////////////////
#txCotSNCF_sal, txCotSNCF_empl_T1, txCotSNCF_empl_T2
txCotisationSNCF <- copy(seriesIPP$paramCotisationPublic$sncf.yaml)[description=="Régime de retraite"]
txCotisationSNCF[, serie:=fcase(sousNiveau=="cotisations_employes",
                                "txCotSNCF_sal",
                                sousNiveau=="cotisations_employeur" & sousDescription=="T1",
                                "txCotSNCF_empl_T1",
                                sousNiveau=="cotisations_employeur" & sousDescription=="T2",
                                "txCotSNCF_empl_T2")][
                                  ,dates:=as.anneeMois(dates)
                                ]
#Attention, les taux sont jusqu'à présent annuels, mais en 2017 on en a deux ici, on garde en date et on adapte le code ?
txCotisationSNCF <- txCotisationSNCF[,.(dates, valeur, serie)][!is.na(valeur)]
txCotisationSNCF <- dcast(txCotisationSNCF, formula = dates ~ serie, value.var = "valeur")
setorder(txCotisationSNCF, dates)
lapply(X =list("txCotSNCF_sal", "txCotSNCF_empl_T1", "txCotSNCF_empl_T2"),
       FUN = function(x)txCotisationSNCF[, x:= nafill(x, type="locf"), env=list(x=x)])

stopifnot(!anyNA(txCotisationSNCF))
stopifnot(nrow(txCotisationSNCF[,.N,.(dates)][N>1])==0)
# txCotisationSNCF <- dcast(txCotisationSNCF[,.(annee, valeur, serie)],
#                          formula = annee ~ serie,
#                          value.var = "valeur",
#                          fun.aggregate = mean)

#Taux cotisation Ircantec (inclut plafond tranche B) /////////////////////////////////////////////////////////////
#txCotIRCANTECsal_TA, txAppel_Ircantec, plafondTBIrcantec,
# txCotIRCANTECsal_TB, txCotIRCANTECempl_TA, txCotIRCANTECempl_TB
txCotisationIrcantec <- copy(seriesIPP$paramCotisationPublic$ircantec.yaml)[
  description=="Taux de cotisation théoriques"|description=="Taux d'appel"]
plafondTBIrcantec <- copy(seriesIPP$paramCotisationPublic$ircantec.yaml)[
  description=="Taux de cotisation appelés" & (sousNiveau=="tranche_b_1_8_pss" | sousNiveau=="tranche_b_1_475_pss")]
txCotisationIrcantec[,annee:=year(dates)]
plafondTBIrcantec[,annee:=year(dates)]
#Détermination 
plafondTBIrcantec <- plafondTBIrcantec[
  ,valeur:=fcase(sousNiveau=="tranche_b_1_8_pss",
                 8,
                 sousNiveau=="tranche_b_1_475_pss",
                 4.75)
]
stopifnot(nrow(plafondTBIrcantec[is.na(valeur)])==0)
plafondTBIrcantec <- plafondTBIrcantec[,.(valeur=max(valeur)),.(annee)][
  ,serie:="plafondTBIrcantec"
]

txCotisationIrcantec[
  ,serie:=fcase(description=="Taux d'appel",
                "txAppel_Ircantec",
                description=="Taux de cotisation théoriques" & sousDescription =="Agent" & sousNiveau=="tranche",
                "txCotIRCANTECsal_TA",
                description=="Taux de cotisation théoriques" & sousDescription =="Agent" & sousNiveau=="tranche_b",
                "txCotIRCANTECsal_TB",
                description=="Taux de cotisation théoriques" & sousDescription =="Employeur" & sousNiveau=="tranche",
                "txCotIRCANTECempl_TA",
                description=="Taux de cotisation théoriques" & sousDescription =="Employeur" & sousNiveau=="tranche_b",
                "txCotIRCANTECempl_TB")]

txCotisationIrcantec <- rbind(txCotisationIrcantec[, .(annee, valeur, serie)],
                              plafondTBIrcantec)

stopifnot(nrow(txCotisationIrcantec[is.na(serie)])==0)
stopifnot(nrow(txCotisationIrcantec[,.N,.(annee, serie)][N>1])==0)


#Taux cotisation RAFP /////////////////////////////////////////////////////////////
#txCotRAFP_sal, txCotRAFP_empl
txCotisationRAFP <- copy(seriesIPP$paramCotisationPublic$rafp.yaml)

#Taux cotisation CNAVPL /////////////////////////////////////////////////////////////
# txCotCNAVPL_T1, txCotCNAVPL_T2
txCotisationCNAVPL <- copy(seriesIPP$paramCotisationLiberaux$ret_pl.yaml)
txCotisationCNAVPL[, annee:=year(dates)]
stopifnot(nrow(txCotisationCNAVPL[,.N,.(sousNiveau, annee)][N>1])==0)
txCotisationCNAVPL[sousNiveau%like%"sous", tranche1Pss := gsub(
  pattern = "(.*_)(.*)(_.*)", x = sousNiveau, replacement = "\\2")]
txCotisationCNAVPL[sousNiveau%like%"entre", tranche2Pss := gsub(
  pattern = "(.*_.*_)(.*)(_.*)", x = sousNiveau, replacement = "\\2")]
txCotisationCNAVPL[, tranche1Pss:=fifelse(tranche1Pss=="085",
                                          0.85,
                                          as.numeric(tranche1Pss))]
txCotisationCNAVPL[, tranche2Pss:=as.numeric(tranche2Pss)]
#On vire les NA qui n'apportent pas d'info
txCotisationCNAVPL <- txCotisationCNAVPL[!is.na(valeur)]
#On fait deux fichiers un de tranche et un de taux
tranchesCotisationCNAVPL <- txCotisationCNAVPL[
  , .(tranche1=mean(tranche1Pss, na.rm=TRUE),
      tranche2=mean(tranche2Pss, na.rm=TRUE)),
  .(annee)]
setorder(tranchesCotisationCNAVPL, tranche1, annee)
tranchesCotisationCNAVPL[, tranche2:=nafill(tranche2, type = "locf"),.(tranche1)]
tranchesCotisationCNAVPL <- tranchesCotisationCNAVPL[
  ,.(annee=min(annee)),.(tranche1, tranche2)]
#Si pas de tranche 2, il n'y a qu'une tranche, pour l'application de la formule plus tard (cotise sur la différence)
#On met la même valeur du coup la différence sera nulle => aucune cotisation ce que l'on veut
tranchesCotisationCNAVPL[is.na(tranche2), tranche2:=tranche1]

txCotisationCNAVPL <- txCotisationCNAVPL[
  , trancheDuTaux := fifelse(sousNiveau %like% "sous",
                             "tauxTranche1",
                             "tauxTranche2")][
                               ,.(annee, valeur, trancheDuTaux, sousNiveau)
                             ]
txCotisationCNAVPL <- txCotisationCNAVPL[,.(annee, tauxCotisation = valeur, trancheDuTaux)]
txCotisationCNAVPL <- dcast(txCotisationCNAVPL, formula = annee ~ trancheDuTaux,
                            value.var = "tauxCotisation" )
txCotisationCNAVPL[is.na(tauxTranche2), tauxTranche2 :=0]

stopifnot(nrow(txCotisationCNAVPL[,.N,.(annee)][N>1])==0)
stopifnot(nrow(txCotisationCNAVPL[is.na(tauxTranche1) | is.na(tauxTranche2)])==0)
stopifnot(nrow(tranchesCotisationCNAVPL[,.N,.(annee)][N>1])==0)
stopifnot(nrow(tranchesCotisationCNAVPL[is.na(tranche1) | is.na(tranche2)])==0)

#Valeur du point de service (pour revalo plus tard) //////////////////////////////////////////////////
#Agirc arrco /////////
#Attention agirc et arrco qui sont des séries historiques, mais besoin de arrco pour la revalo 2019 de l'AA
#Penser à l'étape de la revalo de bbien utiliser la valer 2018 d'arrco pour l'évoluiton
valeurPtServiceAgircArrco <- copy(seriesIPP$parametrePriveAgircArrco$point.yaml)[
  description=="Valeur de service du point ARRCO (en euros)"][
    ,caisse:="Agirc-Arrco"][
      ,.(dateLiq = as.anneeMois(dates), valeurPtService = valeur, caisse)]

# Ircantec ////////
valeurPtServiceIrcantec <- copy(seriesIPP$parametreIrcantec$valeur_du_point.yaml)[
      ,.(dateLiq = as.anneeMois(dates), valeurPtService = valeur, caisse = "Ircantec")]

# RAFP  /////////
valeurPtServiceRafp <- copy(seriesIPP$parametreRafp$valeur_service_point_rafp.yaml)[
    ,.(dateLiq = as.anneeMois(dates),valeurPtService = valeur, caisse = "Rafp")]

#commerçant (RSI avant 2012) ////////
# pointArtisans <- parametreIndependants$pt_rc_art.yaml[,caisse:="Artisans"]
valeurPtServiceCommercants <- copy(seriesIPP$parametreIndependants$pt_rc_com.yaml)[substr(dates, 1,4)<=2012 & !is.na(valeur)][
  ,caisse:="RSI complémentaire"][
    ,.(dateLiq = as.anneeMois(dates),valeurPtService = valeur, caisse)]

#indépendants (RSI après strict 2012)/////////
valeurPtServiceIndependants <- copy(seriesIPP$parametreIndependants$pt_rci.yaml)[
  substr(dates, 1,4)>2012 &
    description=="Valeur du point RCI à date"][
      ,caisse:="RSI complémentaire"][
        ,.(dateLiq = as.anneeMois(dates),valeurPtService= valeur, caisse)]

valeurPtServiceIPP <- rbind(valeurPtServiceAgircArrco, valeurPtServiceIrcantec,
                            valeurPtServiceRafp, valeurPtServiceCommercants,
                            valeurPtServiceIndependants)

stopifnot(nrow(valeurPtServiceIPP[, .N, .(caisse, dateLiq)][N>1])==0)
stopifnot(nrow(valeurPtServiceIPP[is.na(valeurPtService)])==0)

#Valeur du point d'achat  //////////////////////////////////////////////////
#Attention agirc et arrco qui sont des séries historiques, mais besoin de arrco pour la revalo 2019 de l'AA
#Penser à l'étape de la revalo de bbien utiliser la valer 2018 d'arrco pour l'évoluiton
valeurPtAcquisitionAgircArrco <- copy(seriesIPP$parametrePriveAgircArrco$salaire_de_reference.yaml)[
  description=="Salaire de référence AGIRC (valeur d'achat) en euros"][
    ,caisse:="Agirc-Arrco"][
      ,.(annee = year(dates),valeur, caisse)]

valeurPtAcquisitionIrcantec <- seriesIPP$parametreIrcantecSalaireRef$salaire_reference_ircantec.yaml[
  !is.na(valeur)][
    ,caisse:="Ircantec"][
      ,.(annee = year(dates), valeur, caisse)]

valeurPtAcquisitionRafp <- seriesIPP$parametreRafp$valeur_acquisition_point_rafp.yaml[
    ,caisse:="Rafp"][
      ,.(annee = year(dates), valeur, caisse)]

valeurPtAcquisitionCommercants <- seriesIPP$parametreIndependants$salref_rc_com.yaml[
  !is.na(valeur)][
    ,caisse:="RSI complémentaire"][
      ,.(annee = year(dates), valeur, caisse)]

valeurPtAcquisitionIndependants <- seriesIPP$parametreIndependants$salref_rci.yaml[
  ,caisse:="RSI complémentaire"][
    ,.(annee = year(dates), valeur, caisse)]


#On regroupe
valeurPtAcquisitionIPP <- rbind(valeurPtAcquisitionRafp, valeurPtAcquisitionCommercants,
                                valeurPtAcquisitionIndependants, valeurPtAcquisitionIrcantec,
                                valeurPtAcquisitionAgircArrco)
valeurPtAcquisitionIPP <- valeurPtAcquisitionIPP[, .(annee, valeurPtAcquisition = valeur, caisse)]

# valeurPtAcquisitionIPP[
#   , caisse:=factor(caisse, levels=c(paramModele$listeCaissesBase, paramModele$listeCaissesComp))]

stopifnot(nrow(valeurPtAcquisitionIPP[, .N, .(caisse, annee)][N>1])==0)
stopifnot(nrow(valeurPtAcquisitionIPP[is.na(valeurPtAcquisition)])==0)
#Revalorisation pension CNAV //////////////////////////////////////////////////
revaloCnav <- copy(seriesIPP$parametrePriveCnav$revalorisation_pension.yaml)
revaloCnav <- revaloCnav[
  ,dateValeurPension:=as.anneeMois(dates)][
    ,dates:=NULL]
#On démultiplie la table par le nombre de caisses alignées à la CNAV
revaloCnav <- data.table(caisse=paramModele$listeCaissesRegimesAlignes,
                         dummy=1)[revaloCnav[,dummy:=1],
                                  on=.(dummy),
                                  allow.cartesian=TRUE][,dummy:=NULL]

stopifnot(nrow(revaloCnav[, .N, .(caisse, dateValeurPension)][N>1])==0)
stopifnot(nrow(revaloCnav[is.na(valeur)])==0)
list(seriesIPP = list(garantieMinimalePtsAgirc = garantieMinimalePtsAgirc, mico=mico,
     pointIndiceFP=pointIndiceFP, nbAnPourSam=nbAnPourSam,
     ageTauxPleinRG=ageTauxPleinRG, revaloSalaireSam=revaloSalaireSam, 
     avts=avts, txCotisationRSI=txCotisationRSI,
     txCotisationSNCF=txCotisationSNCF,
     txCotisationIrcantec=txCotisationIrcantec, 
     txCotisationCNAVPL=txCotisationCNAVPL,
     tranchesCotisationCNAVPL=tranchesCotisationCNAVPL,
     valeurPtServiceIPP=valeurPtServiceIPP, 
     valeurPtAcquisitionIPP=valeurPtAcquisitionIPP, revaloCnav=revaloCnav))

}

#'@export
conciliationParam<-
  function(seriesIPP, parametres, seriesProlongees, paramModele, seriesConnuesCor){
#Certains paramètres IPP remplacent directement ceux historiques de trajectoire
#D'autre les remplacent sur leur passé,
# ou même un partie de leur passé si trajectoire a une profondeur historique plus importante par exemple
#Il faut aussi mettre à jour les taux de cotisation récupéré à l'IPP
#Ou seulement certaines caisses (revalorisation pension uniquement cnav chez IPP)
#"valeurPtServiceIPP", "valeurPtAcquisitionIPP", "revaloCnav"

#Jointure mais attention si des dates diffèrent il vaut mieux eviter le : "si non NA d'IPP alors IPP"

#On coupe le futur si l'on a l'IPP car c'est projeté en 2.18

conciliationParametresTrajectoireIPP <- function(
    tableIPP_, tableTrajectoire_, cleTemps,
    variableValeurTrajectoire,
    variableValeurIPP = paste0(variableValeurTrajectoire, "_ipp")){
  #On coupe le futur si l'on a l'IPP car c'est projeté en 2.18
  result <- merge.data.table(
    tableTrajectoire_,
    tableIPP_,
    by=c( "caisse", cleTemps),
    suffixes = c("", "_ipp"),
    all = T)
  dateMinIpp <- tableIPP_[
    , .(cleTempsMin = min(cleTemps)), .(caisse),
    env=list(cleTemps=cleTemps)]
  
  result <- dateMinIpp[
    result, on=.(caisse)]
  
  #la condition cleTempsMin<..cleTemps implique qu'on garde nçotre historique en niveau et pas juste évolution,
  #normalement ça ne change pas grand chose
  result <- result[
    is.na(cleTempsMin) | !is.na(variableValeurIPP) | cleTempsMin<cleTemps,
    env=list(cleTemps=cleTemps,
             variableValeurIPP=variableValeurIPP)
  ]
  
  result[!is.na(variableValeurIPP), variableValeurTrajectoire := variableValeurIPP,
         env=list(variableValeurTrajectoire=variableValeurTrajectoire,
                  variableValeurIPP=variableValeurIPP)]
  
  result <- result[, .(caisse, cleTemps, variableValeurTrajectoire),
                   env=list(cleTemps=cleTemps,
                            variableValeurTrajectoire=variableValeurTrajectoire)]
  return(result)
}

conciliationAgircArrco <- function(tableAgircArrco, tableIPP, cleTemps, cleValeur){
  
  derniereDateIPP <- tableIPP[caisse=="Agirc-Arrco"][
    ,.(maxCleTemps = max(cleTemps)), env=list(cleTemps=cleTemps)]
  
  derniereValeurIPP <- tableIPP[
    caisse=="Agirc-Arrco" & cleTemps==derniereDateIPP$maxCleTemps, env=list(cleTemps=cleTemps)][
      ,.(derniereValeurValeur = cleValeur), env=list(cleValeur=cleValeur)]
  
  tableAgircArrco <- tableAgircArrco[order(caisse, hypSmpt, cleTemps), env=list(cleTemps=cleTemps)]
  
  tableAgircArrco[, evol := cleValeur/shift(cleValeur, type="lag"),.(hypSmpt), env=list(cleValeur=cleValeur)]
  
  stopifnot(nrow(tableAgircArrco[cleTemps==derniereDateIPP$maxCleTemps, env=list(cleTemps=cleTemps)])>0)
  
  tableAgircArrco <- tableAgircArrco[cleTemps>derniereDateIPP$maxCleTemps, env=list(cleTemps=cleTemps)]
  
  tableAgircArrco[,evolCum:=cumprod(evol),.(hypSmpt)]
  
  tableAgircArrco[, cleValeur:=derniereValeurIPP$derniereValeurValeur*evolCum, env=list(cleValeur=cleValeur)]
  #On duplique la table IPP pour chaque hypothèse smpt
  tableIPPAA <- rbindlist(lapply(X = tableAgircArrco[
    , unique(hypSmpt)], 
    FUN = function(x){copy(tableIPP)[
      caisse=="Agirc-Arrco"][,hypSmpt:=x]}))
  
  tableAgircArrco <- rbind(tableAgircArrco[
    ,.(cleTemps, caisse, hypSmpt, cleValeur),
    env=list(cleTemps=cleTemps, cleValeur=cleValeur)],
    tableIPPAA
  )
  tableAgircArrco <- tableAgircArrco[order(caisse, hypSmpt, cleTemps), env = list(cleTemps=cleTemps)]
}

#valeurPtService : IPP a moins de profondeur historique pour Ircantec et RSIcomplémentaire §§§§§§§§
#IPP ne traite que AA, Ircantec, RAFP et RSI complémentaire

#Deux fichiers de pt de service, dont un uniquement pour l'agirc-arrco qui se  veut suivre les projections du COR
valeurPtService <- conciliationParametresTrajectoireIPP(
  tableIPP_ = seriesIPP$valeurPtServiceIPP[!caisse=="Agirc-Arrco"],
  tableTrajectoire_ = parametres$valeurPtService,
  cleTemps = "dateLiq",
  variableValeurTrajectoire = "valeurPtService"
)

valeurPtService <- rbind(valeurPtService, seriesIPP$valeurPtServiceIPP[caisse=="Agirc-Arrco"])

stopifnot(nrow(valeurPtService[, .N, .(caisse, dateLiq)][N>1])==0)

# ptServiceAgircArrco <- conciliationAgircArrco(tableAgircArrco = ptServiceAgircArrcoCor[,caisse:="Agirc-Arrco"],
#                                               tableIPP = valeurPtServiceIPP,
#                                               cleTemps = "dateLiq",
#                                               cleValeur = "valeurPtService")
# stopifnot(nrow(ptServiceAgircArrco[, .N, .(caisse, dateLiq, hypSmpt)][N>1])==0)

#valeurPtAcquisition §§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§

valeurPtAcquisition <- conciliationParametresTrajectoireIPP(
  tableIPP_ = seriesIPP$valeurPtAcquisitionIPP[!caisse=="Agirc-Arrco"],
  tableTrajectoire_ = parametres$valeurPtAcquisition,
  cleTemps = "annee",
  variableValeurTrajectoire = "valeurPtAcquisition"
)

valeurPtAcquisition <- rbind(valeurPtAcquisition, seriesIPP$valeurPtAcquisitionIPP[caisse=="Agirc-Arrco"])

# ptAcquisitionAgircArrco <- conciliationAgircArrco(tableAgircArrco = ptAcquisitionAgircArrcoCor[,caisse:="Agirc-Arrco"],
#                                                   tableIPP = valeurPtAcquisitionIPP,
#                                                   cleTemps = "annee",
#                                                   cleValeur = "valeurPtAcquisition")
# stopifnot(nrow(ptAcquisitionAgircArrco[, .N, .(caisse, annee, hypSmpt)][N>1])==0)

#revalo §§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§§

revalo <- conciliationParametresTrajectoireIPP(
  tableIPP_ = seriesIPP$revaloCnav[, caisse:=factor(caisse, levels=levels(parametres$revalo$caisse))],
  tableTrajectoire_ = parametres$revalo[!caisse=="Agirc-Arrco"],
  cleTemps = "dateValeurPension",
  variableValeurTrajectoire = "revalo",
  variableValeurIPP = "valeur"
)

#Revalorisation des régimes à points calée sur l'évolution de la valeur de service du point §§§§§§§§§§§§§§§§
#Attention Agirc Arrco, n'est déjà plus dans valeurPtService à ce niveau, on fait comme la valeur des point on crée une table à part
revaloPoint <- copy(valeurPtService)

setorder(revaloPoint, caisse, dateLiq)
revaloPoint[, revalo:=valeurPtService/shift(valeurPtService, type = "lag"),
            by=.(caisse)]
#Avce le rolling join il nous faut la première revalo non NA et égale à 1 pour tt les dates jusqu'à la première revalo nn nulle
revaloPoint[is.na(revalo), revalo:=1]
revaloPoint <- revaloPoint[,.(caisse, dateValeurPension = dateLiq, revalo)]

revaloPoint[, caisse:=factor(caisse, levels=levels(..revalo$caisse))]

revalo <- conciliationParametresTrajectoireIPP(
  tableIPP_ = revaloPoint,
  tableTrajectoire_ = parametres$revalo,
  cleTemps = "dateValeurPension",
  variableValeurTrajectoire = "revalo"
)

# montant de la retraite forfaitaire MSA exploitant (projection AVTS à partir de 2014) /////////////
#https://www.legifrance.gouv.fr/codes/id/LEGISCTA000006197991/

montantRetraiteForfaitaireMsaExploitant <- seriesIPP$avts[dateLiq<anneeMois(2014)]
derniereValeurAvts <- montantRetraiteForfaitaireMsaExploitant[dateLiq==max(dateLiq)]$avts
#Il faut completer entre début 2014 et 2019 car revalo régime général d'abord en octobre, puis en janvier (en 2019)
#Car pour projeter on n'a qu'un mois de projection possible
revaloApres2014 <- seriesProlongees$revaloRBCor[date>=anneeMois(2014) & date<anneeMois(2019)]
revaloApres2014[, revalo := cumprod(1+revaloRBCor/100)]
revaloApres2014[,avts:=derniereValeurAvts*revalo]
montantRetraiteForfaitaireMsaExploitant <- rbind(montantRetraiteForfaitaireMsaExploitant,
                                                 revaloApres2014[,.(dateLiq=date, avts)])
setnames(montantRetraiteForfaitaireMsaExploitant, "avts", "value")
# stopifnot(nrow(revalo[, .N, .(caisse, dateValeurPension)][N>1])==0)

# revaloAgircArrco <- ptServiceAgircArrco[order(caisse, hypSmpt, dateLiq)][
#   ,revalo:=valeurPtService/shift(valeurPtService, type="lag"), by=.(caisse, hypSmpt)][
#     !is.na(revalo)][
#       ,valeurPtService:=NULL
#     ]
# 
# setnames(revaloAgircArrco, "dateLiq","dateValeurPension")
parametres$montantRetraiteForfaitaireMsaExploitant <- montantRetraiteForfaitaireMsaExploitant
parametres$revalo <- revalo
parametres$nbAnPourSam <- seriesIPP$nbAnPourSam
parametres$valeurPtAcquisition <- valeurPtAcquisition
parametres$valeurPtService <- valeurPtService
parametres$pointIndiceFP <- seriesIPP$pointIndiceFP
parametres$avts <- seriesIPP$avts
# mico de COR ou IPP ??
parametres$mico <- unique(rbind(seriesConnuesCor$mico, seriesIPP$mico))
parametres$txCotisationRSI <- seriesIPP$txCotisationRSI
parametres$txCotisationSNCF <- seriesIPP$txCotisationSNCF
parametres$txCotisationCNAVPL <- seriesIPP$txCotisationCNAVPL
parametres$tranchesCotisationCNAVPL <- seriesIPP$tranchesCotisationCNAVPL
parametres$garantieMinimalePtsAgirc <- seriesIPP$garantieMinimalePtsAgirc

parametres <- c(parametres, seriesConnuesCor)
list(parametres = parametres)}

#' @export
choixMethodeProlongement <- function(valeurPtService, valeurPtAcquisition, 
                                     paramModele){
# mis en 1 pour pouvoir être modifié facilement en variante

# la table methodeProlongement contient toute l'info pour les prolongements de paramètres
# la série est celle que l'on veut prolonger (avec possiblement la caisse concernée)
# la série de référence est celle utilisée pour prolonger la série
# On indique le typeSerie et le typeSerieReference (niveau ou variation) car ça va modifier le codage du prolongement
# le moisEvol prend en compte que certaines revalo ou hausse des points ne tombent pas en janvier
# on choisit de garder une série revalo AA et valeurPtService AA alors qu'elles sont reliées mathématiquement,
# cela permet d'avoir la liberté de briser cette relation en projection
  ## erreur si warning de recyclage
  options(warn=2)
  methodeProlongement <- 
    data.table(
      serie =  c("complementDiffRCO","aspa","pss","smic","salaireValidant","smicAVPF","plafondMico","revaloSam",
                 rep("smpt",length(setdiff(paramModele$listeCaissesBase,"Régime spécial"))),
                 rep("revalo",length(paramModele$listeCaissesBase)+length(
                   setdiff(paramModele$listeCaissesComp,c('Complémentaire régimes spéciaux')))
                 ),
                 "revaloMico", 
                 rep("valeurPtService",length(unique(valeurPtService[,caisse]))-2),
                 rep("valeurPtAcquisition",length(unique(valeurPtAcquisition[,caisse]))-3),
                 "plafondCARMF","plancherCARMF",
                 "montantRetraiteForfaitaireMsaExploitant", rep("mico",2),"vfuCoefIrcantec",rep("vfuSeuilEuro",2),
                 rep("smptTraitementsCor",length(setdiff(paramModele$listeCaissesBase,"Régime spécial")))),
      sousVariable =  c(rep(NA,8),
                        setdiff(paramModele$listeCaissesBase,"Régime spécial"), 
                        paramModele$listeCaissesBase,setdiff(paramModele$listeCaissesComp,c('Complémentaire régimes spéciaux')),
                        rep(NA,1),
                        setdiff(as.character(unique(valeurPtService[,caisse])),c("Agirc","Arrco")),
                        setdiff(as.character(valeurPtAcquisition[,unique(caisse)]),c("Agirc","Arrco","Nouveau système")),
                        rep(NA,3),"micoPlein","micoMajorePlein",NA,"Cnav","MSA salarié",
                        setdiff(paramModele$listeCaissesBase,"Régime spécial"))
    )
  
methodeProlongement[,typeSerie:=fcase(
  serie=="revaloSam",  "taux de croissance en %",
  serie %like% "revalo", "coefficient multiplicateur", default = "niveau")]

methodeProlongement[,serieReference:=fcase(
  serie %in% c("valeurPtService","revalo") & sousVariable%in%c("Agirc-Arrco","Agirc","Arrco"), "ptServiceAgircArrcoCor",
  serie == "valeurPtAcquisition"& sousVariable%in%c("Arrco","Agirc-Arrco"), "ptAcquisitionAgircArrcoCor",
  serie == "smpt" | serie== "smptTraitementsCor", paste0("smptTraitementsCor[caisse=='",sousVariable,"']"),
  serie == "mico", paste0("micoCor[variable=='",sousVariable,"']"),
  serie == "pss", "pssCor",
  serie == "complementDiffRCO","complementDiffRCOCor",
  serie == "aspa", "aspaCor",
  serie %in% c("smic","vfuCoefIrcantec"), "smicCor",
  serie == 'revaloSam', "revaloSamCor",
  serie == "salaireValidant", paste0("salaireValidantCor"),
  serie == "smicAVPF", paste0("smicAVPFCor"),
  serie == "plafondMico", paste0("plafondMicoCor"),
  default = "revaloRBCor"
)]
methodeProlongement[,typeSerieReference:=fifelse(
  serieReference %in%c("revaloSamCor","revaloRBCor") | serieReference %like% "smptTraitementsCor", 
  "taux de croissance en %", "niveau")]

methodeProlongement[, moisEvol := fcase(
  sousVariable %in% c("Agirc","Arrco","Agirc-Arrco"), 11,
  sousVariable%in%c("CNAVPL","Exploitant agricole") & serie!="smpt", 10,
  sousVariable == "MSA exploitant complémentaire" & serie=='revalo', 10,
  serie == "vfuSeuilEuro", 4,
  default = 1)
]
methodeProlongement[sousVariable=="CAVIMAC", serieReference:=gsub("CAVIMAC","CNIEG", serieReference)]
options(warn=0)
list(methodeProlongement = methodeProlongement)}

#' @export
choixHypSmptCor <- function(seriesProlongees, paramModele, parametres){
seriesCor <- c("pssCor", "ptAcquisitionAgircArrcoCor",
               "ptServiceAgircArrcoCor",
               "smicCor","salaireValidantCor","smicAVPFCor","plafondMicoCor",
               "pibCor","smptTraitementsCor","traitementEtPrimes",'prixCor',
               "complementDiffRCOCor")

for(x in seriesCor){
  seriesProlongees[[x]] <-  seriesProlongees[[x]][hypSmpt==paramModele$hypSmpt,!"hypSmpt"]
}
parametres$inflation <- seriesProlongees$prixCor
# prolongement spécifique SMPT  pour calculs, entre autres, du TRI.
# il faut que les séries aillent jusqu'en genMax+ageMortMax pour avoir la pensionCDV 
# rapportée au SMPT 
setorder(seriesProlongees$smptTraitementsCor, "caisse",'annee')
seriesProlongees$smptTraitementsCor<-rbind(seriesProlongees$smptTraitementsCor,
                          seriesProlongees$smptTraitementsCor[,tail(.SD,1), caisse][
                            ,.(annee=(annee[1]+1):(paramModele$genMax+paramModele$ageMortMax),
                               evolution=evolution[1]),caisse])
setorder(seriesProlongees$smptTraitementsCor, "caisse",'annee')
list(seriesProlongees = seriesProlongees, parametres = parametres)
}

#' @export
creationSmptHistorique <- function(
    smptHistorique=parametres$smptHistorique,
    pointIndiceFP=parametres$pointIndiceFP,
    paramModele,parametres, seriesProlongees){
      ## passage en moyenne annuelle le point d'indice
      ptIndice<-pointIndiceFP[
        data.table(dateLiq=as.anneeMois(seq(anneeMois(1970,1),anneeMois(paramModele$anneeActuelle,12),1))),
        on="dateLiq", roll=Inf][,annee:=extraireAnnee(dateLiq)][,.(valeur=mean(valeur)),annee]

      smptFP<-
        ptIndice[
          ,.(
            annee,
            smptFP=valeur*smptHistorique[annee==paramModele$anneeActuelle,smpt]/ptIndice[annee==paramModele$anneeActuelle,valeur]
          )]

      #Rustine 2ieme tentative
      smptFP[annee==2022, smptFP := smptFP * 58.2004/56.232300]

      # comme la série de pt d'indice commence en 1970, avant on prolonge par le SMPT général
      smptFP<-rbind(
        smptHistorique[annee<1970,.(annee, smptFP=smptFP[annee==1970, smptFP]*smpt/smptHistorique[annee==1970, smpt])],
        smptFP)

      listeCaisses<-setdiff(paramModele$listeCaissesBase, "Régime spécial")
      smpt<-CJ(annee=min(smptHistorique$annee):paramModele$anneeActuelle, caisse=listeCaisses)
      smpt<-smptHistorique[smpt, on="annee"]
      smpt<-smptFP[smpt, on="annee"]
      smpt<-smpt[
        ,.(annee, caisse, smpt=fifelse(caisse %in% c("SRE","CNRACL"), smptFP, smpt))]
      parametres$smpt <- smpt
      
      #Attention, on veut aussi garder le smpt du fichier du COR
      parametres$smptTraitementsCor <- copy(seriesProlongees$smptTraitementsCor)
      
      parametres$smptTraitementsCor <- parametres$smptTraitementsCor[
        , smptAnneeBase := parametres$smptHistorique[annee==paramModele$anneeActuelle,smpt]]
      
      parametres$smptTraitementsCor[, evolution := cumprod(1+evolution/100), .(caisse)]
      
      parametres$smptTraitementsCor <- parametres$smptTraitementsCor[
        parametres$smptTraitementsCor[annee==paramModele$anneeActuelle][
          ,.(caisse, evolutionAnneeBase = evolution)], on =.(caisse)
      ]
      
      parametres$smptTraitementsCor <- parametres$smptTraitementsCor[
        , .(annee, caisse, smpt = smptAnneeBase * evolution / evolutionAnneeBase)]
      
      list(parametres = parametres)
      }


# creationSmptHistorique <- function(
#     smptHistorique=parametres$smptHistorique,
#     pointIndiceFP=parametres$pointIndiceFP,paramModele){
#   #Rustine à faire sauter si fichier maj avec indice 2022
#   #ATTENTION ici on suppose une égalité de SMPT en 2022, ce n'est pas neutre du tout
#   if(nrow(pointIndiceFP[extraireAnnee(dateLiq)==2022])==0){
#     pointIndiceFP <- rbind(pointIndiceFP,
#                            data.table(valeur = 58.2004,
#                                       dateLiq = anneeMois(2022, 07)))
#   }else{
#     stop("faire sauter la rustine")
#   }
#   
# ## passage en moyenne annuelle le point d'indice
# ptIndice<-pointIndiceFP[
#   data.table(dateLiq=as.anneeMois(seq(anneeMois(1970,1),anneeMois(paramModele$anneeActuelle,12),1))),
#   on="dateLiq", roll=Inf][,annee:=extraireAnnee(dateLiq)][,.(valeur=mean(valeur)),annee]
# #Pas 2022 car n'inclus pas la revalo
# # ptIndice <- ptIndice[annee<2022]
# anneeEnCours <- paramModele$anneeActuelle
# #Attention, on définit la base à 2017 : 
# #important si on bouge ensuiste les année jusqu'où on utilise les points d'indice pour ne pas changer le changer
# #2017 car année à partir de laquelle on a l'évol smpt par caisse : cf.seriesProlongees$smptTraitementsCor
# smptFP<-
#   ptIndice[
#     ,.(
#       annee,
#       smptFP=valeur*smptHistorique[annee==2017,smpt]/ptIndice[annee==2017,valeur]
#     )]
# 
# # comme la série de pt d'indice commence en 1970, avant on prolonge par le SMPT général
# smptFP<-rbind(
#   smptHistorique[annee<1970,.(annee, smptFP=smptFP[annee==1970, smptFP]*smpt/smptHistorique[annee==1970, smpt])],
#   smptFP)
# 
# listeCaisses<-setdiff(paramModele$listeCaissesBase, "Régime spécial")
# smpt<-CJ(annee=min(smptHistorique$annee):anneeEnCours, caisse=listeCaisses)
# smpt<-smptHistorique[smpt, on="annee"]
# smpt<-smptFP[smpt, on="annee"]
# smpt<-smpt[
#   ,.(annee, caisse, smpt=fifelse(caisse %in% c("SRE","CNRACL"), smptFP, smpt))]
# smpt}

#'@export
prolongementParametres <- 
  function(
    methodeProlongement,
    parametres,
    paramModele,
    seriesProlongees){

# moisEvol != 1 si on veut que la série ne soit pas revalorisée en janvier
prolongeSimple<-
  function(serie, nomSerie, typeSerie, serieRef, nomSerieRef,
           typeSerieReference, moisEvol = 1, sousVariable){
    #res<-get(serie)
    
    # mise au propre de la série  
    cleTemps <- intersect(names(serie), c("dateLiq", "annee","dateValeurPension","date"))
    if(length(cleTemps)==0){stop("cle temporelle de la serie ", nomSerie, " pas trouvée")}
    sousVariable <- intersect(names(serie), c("caisse", "variable"))
    if(length(sousVariable)!=0){
      valeurSousVariable=serie[1,sousVariable, env=list(sousVariable=sousVariable)]}
    nomValeurSerie <- setdiff(names(serie), c(cleTemps,sousVariable))
    if(length(nomValeurSerie)!=1){stop("la série à prolonger contient plusieurs colonnes de valeurs, une seule nécessaire")}
    # on change le nom de la colonne des valeurs en valeur pour se simplifier la vie
    setnames(serie, nomValeurSerie, "valeur")
    # tri au cas où
    setorderv(serie, cleTemps)
    # on ajoute une variable année 
    if(cleTemps != "annee"){
      serie[, annee:=extraireAnnee(cleTemps), env=list(cleTemps=cleTemps)]}
    
    # mise au propre de la série de référence
    serieRefC <- copy(serieRef)
    cleTempsRef <- intersect(names(serieRefC), c("dateLiq", "annee","dateValeurPension","date"))
    sousVariableRef <- intersect(names(serieRefC), c("caisse", "variable"))
    nomValeurSerieRef <- setdiff(names(serieRefC), c(cleTempsRef,if(length(sousVariable)!=0){sousVariableRef}))
    if(length(nomValeurSerieRef)!=1){stop("la série pour prolonger contient plusieurs colonnes de valeurs, une seule nécessaire")}
    # on change le nom de la colonne des valeurs en valeur pour se simplifier la vie
    setnames(serieRefC, nomValeurSerieRef, "valeurRef")
    # tri au cas où
    setorderv(serieRefC, cleTempsRef)
    # on décide de passer en annuel 
    if(cleTempsRef != "annee"){
      serieRefC[, annee:=extraireAnnee(cleTempsRef), env=list(cleTempsRef=cleTempsRef)]
    }
    # si la serie Ref en taux de croissance a plusieurs valeurs annuelles et on veut prolonger une série en niveau,
    # il faut sommer
    if(typeSerieReference=="taux de croissance en %" & typeSerie=="niveau"){
      serieRefC<-serieRefC[, .(valeurRef=sum(valeurRef)),annee]
      cleTempsRef <- "annee"
      }
    
    # si la série de référence est en niveau, il faut calculer ses variations pour
    # les appliquer à la série à prolonger
    if(typeSerieReference == "niveau"){
      # il faut que la colonne des valeurs ait le même nom que la base
      serieRefC[, valeurRef:=100*(valeurRef/shift(valeurRef)-1)]
    }
    # prolongement de la serieRef jusqu'à genMax + ageMortMax pour être sûr 
    # (nécessaire pour pension cycle de vie par exemple)
    if(max(serieRefC$annee, na.rm=TRUE) < paramModele$genMax+paramModele$ageMortMax){
      serieRefC <- 
        rbind(
          serieRefC,
          data.table(
            annee=seq(
              max(serieRefC$annee)+1,
            paramModele$genMax+paramModele$ageMortMax)
            ), fill = TRUE)
      serieRefC <- serieRefC[order(annee)][,valeurRef:=nafill(valeurRef, "locf")]
      if(cleTempsRef != "annee"){
        serieRefC[is.na(cleTemps),cleTemps:=anneeMois(annee, moisEvol), env=list(cleTemps=cleTempsRef)]
      }
      if(length(sousVariableRef)!= 0){
        serieRefC[
          ,sousVariable:=serieRefC[1,sousVariable, env = list(sousVariable=sousVariableRef)], env = list(sousVariable=sousVariableRef)]
      }
    }
    
    dernierPoint = tail(serie, 1)
    prolongement <- 
      serieRefC[annee>dernierPoint$annee]
    if(anyNA(prolongement[,.(annee, valeurRef)])){
      stop("la série de référence ",nomSerieRef, " a des NA pour prolonger (ou est trop courte)")}
    setnames(prolongement, "valeurRef","valeur")
    # si la série à prolonger est en niveau, il faut calculer les évolutions 
    if(typeSerie == "niveau"){ 
      prolongement[
        , valeur:=dernierPoint$valeur*cumprod(1+valeur/100)]
    }
    if (typeSerie == "coefficient multiplicateur"){ 
      prolongement[,valeur:=(1+valeur/100)]
    }
    # si la série initiale n'était pas en année, on ajoute le mois d'évolution
    if(cleTemps!="annee" & cleTempsRef=="annee"){
      prolongement[,cleTemps:=anneeMois(annee, moisEvol), env=list(cleTemps=cleTemps)]
    } else if(cleTemps!="annee" & cleTempsRef!=cleTemps){
      setnames(prolongement, cleTempsRef, cleTemps)
    }
    if(length(sousVariable)!=0){
      serie<-
        rbind(
          serie[,.(cleTemps,sousVariable,valeur),env=list(cleTemps=cleTemps, sousVariable=sousVariable)],
          prolongement[,.(cleTemps,sousVariable = valeurSousVariable,valeur),env=list(cleTemps=cleTemps, sousVariable=sousVariable)])}
    else {
            serie<-
              rbind(
                serie[,.(cleTemps,valeur),env=list(cleTemps=cleTemps)],
                prolongement[,.(cleTemps,valeur),env=list(cleTemps=cleTemps)])    
          }
    # on remet le nom originel de la colonne valeur de la série
    setnames(serie, "valeur", nomValeurSerie)
    if(anyDuplicated(serie[,cleTemps, env=list(cleTemps=cleTemps)])!=0){
      stop("Après prolongement clés dupliqués dans ", nomSerie)}
    serie}

# prolongement simple des séries
for(i in 1:nrow(methodeProlongement)){
  assign(x =
           ifelse(
             is.na(methodeProlongement[i,sousVariable]),
             methodeProlongement[i,serie],
             paste0(
               methodeProlongement[i,serie],".",
               make.names(methodeProlongement[i,sousVariable]))
           ),
         value = prolongeSimple(
           serie = if(is.na(methodeProlongement[i,sousVariable])){
             eval(parse(text=paste0("parametres$",methodeProlongement[i,serie])))} else {
               eval(parse(text=paste0("parametres$",methodeProlongement[i,serie])))[
                 sousVariable1==sousVariable2,env=list(
                   sousVariable2=I(methodeProlongement[i,sousVariable]),
                   sousVariable1=intersect(names(eval(parse(text=paste0("parametres$",methodeProlongement[i,serie])))),c("caisse","variable")))]},
           nomSerie = methodeProlongement[i,serie],
           typeSerie = methodeProlongement[i,typeSerie],
           sousVariable = methodeProlongement[i,sousVariable],
           serieRef = eval(parse(text=paste0("seriesProlongees$",methodeProlongement[i,serieReference]))),
           nomSerieRef = methodeProlongement[i,serieReference],
           typeSerieReference = methodeProlongement[i,typeSerieReference],
           moisEvol = methodeProlongement[i,moisEvol]
           
         ))
}

# les caisses Agirc et Arrco n'ont que des valeurs historiques (pas de projection),
# il faut les sauvegarder et les ajouter ensuite
valeurPtAcquisitionHist <- parametres$valeurPtAcquisition[caisse %in% c("Agirc", "Arrco")]
valeurPtServiceHist <- parametres$valeurPtService[caisse %in% c("Agirc", "Arrco")]

# regroupement pour les éléments à regrouper 
for(i in methodeProlongement[,.N,serie][N>1]$serie){
  parametres[[i]]<-
    rbindlist(lapply(grep(pattern = paste0(i,"\\."),ls(),value=TRUE),get,get, envir=sys.frame(sys.parent(0))))
  #rm(list=grep(pattern = paste0(i,"\\."),ls(),value=TRUE))
}

for(i in methodeProlongement[,.N,serie][N==1]$serie){
  parametres[[i]]<-get(i)
    }

parametres$valeurPtAcquisition<-rbind(parametres$valeurPtAcquisition, valeurPtAcquisitionHist)
parametres$valeurPtService<-rbind(parametres$valeurPtService, valeurPtServiceHist)

parametres$revalo<-rbind(
  parametres$revalo,
  parametres$revalo[caisse=='Rafp'][,caisse:="Complémentaire régimes spéciaux"]
)
parametres$revalo<-parametres$revalo[order(caisse, dateValeurPension)]
parametres$revalo[,cumCoefRevalo:=cumprod(revalo), by=.(caisse)]

list(parametres = parametres)}

#' @export
parametresRelies<-function(parametres){

# on en déduit le smic horaire avec la règle des 150hSMIC (200hSMIC avant 2014)
parametres$smicHoraire<-
  copy(parametres$salaireValidant)[
    ,.(annee, smicHoraire = fifelse(
      annee>=2014, salaireValidant/150,  salaireValidant/200))]

# un jour le PSS viendra de l'IPP et sera pronlogé par le PSS Cor
list(parametres = parametres)
}
